#include <stdlib.h>
#include <gtk/gtk.h> 

#include <SDL/SDL.h>


#include "nSX2.h"
#include "plugin_gs_04/PS2Edefs.h"


GtkWidget *win; 
GtkWidget *vbox;
GtkWidget *menu_bar;
GtkWidget *submenu;
GtkWidget *menu_item;
GtkWidget *scrollbar;

static GtkWidget *StatusBar; 
guint ContextId1;
guint ContextId2;

GtkWidget *EmuOutput;

 

Mips_CPU 		MipsCpu;
Bios_Hw  		Ps2Bios;

SDL_Surface		* MainScreen;
SDL_Surface *screen;				//The Video Screen
SDL_Event		* MainSDLEvent;


char 			ElfToExecute[256];

guint nSX2Idle_funcID;
int nSX2InitProc  (GtkWidget *pWidget, gpointer pData );
int nSX2MainEmuProc (GtkWidget *pWidget, gpointer pData );
int nSX2Idle_nullfunc(GtkWidget *pWidget, gpointer pData) ;

void arreter_boucle(GtkWidget* widget); 

void Quitter(GtkWidget* widget, gpointer data);
void About(GtkWidget* widget, gpointer data);

void gtkcb_LoadElf(GtkWidget* widget, gpointer data);
void recuperer_chemin (GtkWidget *bouton, GtkWidget *file_selection);

void gtkcb_EmuRun(GtkWidget* widget, gpointer data);
void gtkcb_EmuPause(GtkWidget* widget, gpointer data);
void gtkcb_DbgShow (GtkWidget* widget, gpointer data);

float ComputeInstructionsPerSec( void  ) ;


void PrintToEmuOutput (  char * ftext ) {



GtkTextBuffer* text_buffer=0;
GtkTextIter end;




text_buffer=gtk_text_view_get_buffer(GTK_TEXT_VIEW(EmuOutput));
gtk_text_buffer_get_end_iter(text_buffer,&end);


gtk_text_buffer_insert(text_buffer, &end, g_locale_to_utf8(ftext, -1, NULL, NULL, NULL), -1);
gtk_text_buffer_insert(text_buffer, &end, g_locale_to_utf8("\n", -1, NULL, NULL, NULL), -1);

	
//gtk_text_buffer_insert (text_buffer,&end,ftext, strlen(ftext) + 1);

//printf("%s\n",ftext);

}

void PrintToOpcodeOutput (  char * ftext ) {


}

void PrintToRegistersOutput (  char * ftext ) {
	


} 

void PrintToCOP1RegistersOutput (  char * ftext ) {
	


} 

void PrintToPS2StateOutput (  char * ftext ) {
	
}



int main(int argc,char* argv[])
{ 

	
	
    Uint32 rmask, gmask, bmask, amask;	//Mask for the SDL Surface


	/* Initialize SDL */
	if ( SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER  ) < 0 ) {
		printf("Couldn't initialize SDL: %s\n",SDL_GetError());
		exit(1);
	}

	/* Read config File
		If errors happend, no problem this functions load default config
	*/
	nSX2LoadConfig();							


	/* Set the main GUI video Mode */
	screen = SDL_SetVideoMode(muGUI_MainScreenW, muGUI_MainScreenH, muGUI_MainScreenBPP, SDL_HWSURFACE | SDL_DOUBLEBUF | SDL_HWPALETTE );
	SDL_WM_SetCaption("Video Output", NULL);	
 
   if ( screen == NULL ) {
		printf("Couldn't set video mode: %s\n",SDL_GetError());
		fflush(stdout);
		exit(1);
	}
	
	/*
	WARNING: MASK NOT USABLE FOR AN ANOTHER APP
	*/

	#if SDL_BYTEORDER == SDL_BIG_ENDIAN
	    rmask = 0x0000ff00;
	    gmask = 0x00ff0000;
	    bmask = 0xff000000;
	    amask = 0x000000ff;
	#else
	    rmask = 0x00ff0000;
	    gmask = 0x0000ff00;
	    bmask = 0x000000ff;
	    amask = 0xff000000;
	#endif

	/* Creation of the MainPS2Output Video*/
	MainScreen = SDL_CreateRGBSurface( SDL_HWSURFACE  , muGUI_MainScreenW,muGUI_MainScreenH, muGUI_MainScreenBPP,rmask, gmask, bmask, amask);
    if(MainScreen == NULL) printf("CreateRGBSurface failed: %s\n", SDL_GetError());


    SDL_SetAlpha(MainScreen, SDL_RLEACCEL, 0);
    SDL_SetAlpha(	screen, SDL_RLEACCEL, 0);
  


/*Main GTK Init*/
gtk_init(&argc,&argv);

/*Main Window*/
win = gtk_window_new(GTK_WINDOW_TOPLEVEL);                      //
gtk_window_set_title(GTK_WINDOW(win),"nSX2 v0.0.5");            //Title
gtk_window_set_default_size(GTK_WINDOW(win),500,400);           //Size
gtk_window_set_position(GTK_WINDOW(win), GTK_WIN_POS_CENTER );  //Center Position



/*Main Box*/
vbox=gtk_vbox_new(FALSE,0);
gtk_container_add(GTK_CONTAINER(win),vbox);

/*Main Menu*/
menu_bar = gtk_menu_bar_new();

/*File Sub Menu*/
submenu = gtk_menu_new();
/*Menu Item : Load elf*/
menu_item = gtk_menu_item_new_with_label("Load Elf");
g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(gtkcb_LoadElf), win);
gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
/*Menu Item : Quit*/
menu_item = gtk_menu_item_new_with_label("Quitter");
g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(Quitter), win);
gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
/*Sub Menu Name*/
menu_item = gtk_menu_item_new_with_label("File");
/*Add Sub Menu to Menu Bar*/
gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item), submenu);
gtk_menu_shell_append(GTK_MENU_SHELL(menu_bar), menu_item);


/* Emulation Sub Menu*/
submenu = gtk_menu_new();
/* */
menu_item = gtk_menu_item_new_with_label("Run");
g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(gtkcb_EmuRun), win);
gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
/* */
menu_item = gtk_menu_item_new_with_label("Pause");
g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(gtkcb_EmuPause), win);
gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
/* */
menu_item = gtk_menu_item_new_with_label("Emulation");
/* */
gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item), submenu);
gtk_menu_shell_append(GTK_MENU_SHELL(menu_bar), menu_item);


/* Debug Sub Menu*/
submenu = gtk_menu_new();
/* */
menu_item = gtk_menu_item_new_with_label("Show");
g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(gtkcb_DbgShow), win);
gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
/* */
menu_item = gtk_menu_item_new_with_label("Debug");
/* */
gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item), submenu);
gtk_menu_shell_append(GTK_MENU_SHELL(menu_bar), menu_item);


/* Config Sub Menu */
submenu = gtk_menu_new();
/* */
menu_item = gtk_menu_item_new_with_label("Emulation mode");
g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(Quitter), win);
gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
/* */
menu_item = gtk_menu_item_new_with_label("GS");
g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(Quitter), win);
gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
/* */
menu_item = gtk_menu_item_new_with_label("Config");
/* */
gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item), submenu);
gtk_menu_shell_append(GTK_MENU_SHELL(menu_bar), menu_item);


/* About Sub Menu */
submenu = gtk_menu_new();
/* */
menu_item = gtk_menu_item_new_with_label("About...");
g_signal_connect(G_OBJECT(menu_item), "activate", G_CALLBACK(About), win);
gtk_menu_shell_append(GTK_MENU_SHELL(submenu), menu_item);
/* */
menu_item = gtk_menu_item_new_with_label("?");
/* */
gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item), submenu);
gtk_menu_shell_append(GTK_MENU_SHELL(menu_bar), menu_item);


/*Emu Output*/
EmuOutput=gtk_text_view_new();

scrollbar = gtk_scrolled_window_new(NULL, NULL);

gtk_container_add(GTK_CONTAINER(scrollbar),EmuOutput);
gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrollbar), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);



/*Status Bar*/
StatusBar = gtk_statusbar_new();

ContextId1 = gtk_statusbar_get_context_id(GTK_STATUSBAR(StatusBar), "ExitMsg");
ContextId2 = gtk_statusbar_get_context_id(GTK_STATUSBAR(StatusBar), "AboutMsg");

gtk_statusbar_push (GTK_STATUSBAR (StatusBar), GPOINTER_TO_INT(ContextId1), "Emulator : Stop");


/* Add Widget to Box*/
gtk_box_pack_start(GTK_BOX(vbox), menu_bar, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox),EmuOutput,TRUE,TRUE,0);
gtk_box_pack_start(GTK_BOX(vbox), scrollbar, TRUE, TRUE, 0);
gtk_box_pack_end(GTK_BOX(vbox),StatusBar,FALSE,FALSE,0);

/* */
g_signal_connect(G_OBJECT(win),"destroy",G_CALLBACK(arreter_boucle),NULL);

/* */
gtk_widget_show_all(win);

/* idle Function*/


//nSX2Idle_funcID = gtk_idle_add( (GtkFunction)nSX2InitProc ,  NULL );


/* */
gtk_main();






return 0; 
}

void arreter_boucle(GtkWidget* widget)
{
gtk_widget_destroy(widget);
gtk_main_quit();
}

void Quitter(GtkWidget* widget, gpointer data)
{
GtkWidget *question;

question = gtk_message_dialog_new (GTK_WINDOW(data),
GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_MESSAGE_QUESTION,
GTK_BUTTONS_YES_NO,
"Really want to quit ?");

switch(gtk_dialog_run(GTK_DIALOG(question)))
{
case GTK_RESPONSE_YES:
arreter_boucle(data);
break;
case GTK_RESPONSE_NO:
gtk_widget_destroy(question);
break;
}
}

void About(GtkWidget* widget, gpointer data)
{
GtkWidget *about;
gchar *site = "http://nsx2.emulation64.com";

about = gtk_message_dialog_new (GTK_WINDOW(data),
GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_OK,
"neutrinoSX2 v0.0.5\nAn open source PS2 Emulator\n\nby muad\n%s",site);

gtk_dialog_run(GTK_DIALOG(about));

gtk_widget_destroy(about);
}


void gtkcb_LoadElf(GtkWidget* widget, gpointer data) {

GtkWidget *selection;

selection = gtk_file_selection_new( g_locale_to_utf8( "Slectionnez un fichier", -1, NULL, NULL, NULL) );

gtk_file_selection_set_filename (GTK_FILE_SELECTION(selection),"demos\\");
gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION(selection)); 

gtk_widget_show(selection);

//On interdit l'utilisation des autres fenetres.
gtk_window_set_modal(GTK_WINDOW(selection), TRUE);

g_signal_connect(G_OBJECT(GTK_FILE_SELECTION(selection)->ok_button), "clicked", G_CALLBACK(recuperer_chemin), selection );

g_signal_connect_swapped(G_OBJECT(GTK_FILE_SELECTION(selection)->cancel_button), "clicked", G_CALLBACK(gtk_widget_destroy), selection);




}

void recuperer_chemin (GtkWidget *bouton, GtkWidget *file_selection)
{
const gchar* chemin;
GtkWidget *dialog;
chemin = gtk_file_selection_get_filename(GTK_FILE_SELECTION (file_selection) );

/*
dialog = gtk_message_dialog_new(GTK_WINDOW(file_selection),
GTK_DIALOG_MODAL,
GTK_MESSAGE_INFO,
GTK_BUTTONS_OK,
"Vous avez choisi :\n%s", chemin);
*/
gtk_dialog_run(GTK_DIALOG(dialog));
gtk_widget_destroy(dialog);
gtk_widget_destroy(file_selection);

memset(ElfToExecute,0,50);
strcpy( ElfToExecute,chemin);

			/*Change the Idle proc of the Gui*/
            gtk_idle_remove    (nSX2Idle_funcID);
			nSX2Idle_funcID = gtk_idle_add( (GtkFunction)nSX2InitProc ,  NULL );


} 


void gtkcb_EmuRun(GtkWidget* widget, gpointer data)
{
GtkWidget *about;
gchar *site = "http://nsx2.emulation64.com";

about = gtk_message_dialog_new (GTK_WINDOW(data),
GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_OK,
"Emulation Run",NULL);

gtk_dialog_run(GTK_DIALOG(about));

gtk_widget_destroy(about);
}


void gtkcb_EmuPause(GtkWidget* widget, gpointer data)
{
GtkWidget *about;
gchar *site = "http://nsx2.emulation64.com";

about = gtk_message_dialog_new (GTK_WINDOW(data),
GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_OK,
"Emulation Pause",NULL);

gtk_dialog_run(GTK_DIALOG(about));

gtk_widget_destroy(about);
}

void gtkcb_DbgShow (GtkWidget* widget, gpointer data)
{
GtkWidget *about;
gchar *site = "http://nsx2.emulation64.com";

about = gtk_message_dialog_new (GTK_WINDOW(data),
GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_OK,
"Debug Show",NULL);

gtk_dialog_run(GTK_DIALOG(about));

gtk_widget_destroy(about);
}


int nSX2Idle_nullfunc(GtkWidget *pWidget, gpointer pData) {


return TRUE;
}



/*
Initialisation of the EMU
*/
int nSX2InitProc  (GtkWidget *pWidget, gpointer pData ) {
	char 		tempText[100];		//for displaying text to the widget
	static int 	nsx2InitState = 0;	//Function State
	static int	IsInitOK = 0;		//
	int 		result;				//fonction return 
	char 		GSMainTitle[256];	//main windows title	

GtkTextBuffer* text_buffer=0;
GtkTextIter end_text_buffer,start_text_buffer;


	switch ( nsx2InitState ) {
		/* Print some infos */
		case 0:	{

            text_buffer=gtk_text_view_get_buffer(GTK_TEXT_VIEW(EmuOutput));
            gtk_text_buffer_get_end_iter(text_buffer,&end_text_buffer);
            gtk_text_buffer_get_start_iter(text_buffer,&start_text_buffer);
			gtk_text_buffer_delete(text_buffer, &start_text_buffer, &end_text_buffer);
      
   			sprintf(tempText,"nSX2 %d.%d by Muad - 2002 ( build date : %s )",  nSX2_VERSION, nSX2_BUILD,sSX2_BUILD_DATE);
			PrintToEmuOutput(tempText);	
			
			sprintf(tempText,"|  web  : http://nsx2.emulation64.com");
			PrintToEmuOutput(tempText);	
			
			sprintf(tempText,"|_ mail : atreides.muaddib@caramail.com");
			PrintToEmuOutput(tempText);		
		
			IsInitOK = 0;

			break;
		}
		
		/*Open the elf File */
		case 1: {
		    
			result = ElfOpenFile(ElfToExecute);					if ( result == FALSE )  IsInitOK++;
			break;			
		}
		
		/*Open the BIOS File */
		case 2: {
			//result = BiosOpenFile( "bios/scph10000.bin" ) ;		if ( result == FALSE )  IsInitOK++;
			break;		
		}
		
		/*Various Memory Allocation */
		case 3: {
			
			FreeAllMemory();
			
			
			result = MipsMemoryAlloc();							if ( result == FALSE )  IsInitOK++;
			result = MipsSpecialAreaMemoryAlloc( );				if ( result == FALSE )  IsInitOK++;
			result = MipsGSAreaMemoryAlloc();					if ( result == FALSE )  IsInitOK++;
			result = MipsBiosMemoryAlloc( );					if ( result == FALSE )  IsInitOK++;
			
			
			
			break;
		}
	
		
		/*If something wrong*/
		case 4: {
			if ( IsInitOK != 0 ) {
				sprintf(tempText,"FATAL ERROR while emulator initialisation....Sorry Exiting");	
				PrintToEmuOutput(tempText);
				//nSX2GUI.status = muGUI_STATUS_STOP;
			}
			break;
		}
	
		/*Read the header of the Elf File*/
		case 5: {
			
			ElfLoadHeader();
			
			break;
		}
	
		/*Copy the program to memory according the elf header*/
		case 6: {	
		CopyProgramToMemory(  ) ;
			break;
		}
		
		/*Copy data to memory according the elf header*/
		case 7: {	
			CopySectionToMemory( );
			break;
		}
		
		/*Copy Bios to Memory */
		case 8: {
			//CopyBiosToMemory ( );	
			break;	
		}
	
		/* Initialisation of GS plugin */
		case 9: {	
			
			GSinit();
			result = GSopen(MainScreen ,GSMainTitle );
		
			if ( result != 0 ) {
				sprintf(tempText,"FATAL ERROR while graphics initialisation...Sorry Exiting");
				PrintToEmuOutput(tempText);
				//nSX2GUI.status = muGUI_STATUS_STOP;
				
			} else {
				sprintf(tempText,"GS:OK");
				PrintToEmuOutput(tempText);			
			}
			break;	
		}

		/*Various PS2 Initialisation */
		case 10: {	
			
			Ps2Bios.NeedUpdateScreen 			= 0;
			MipsCpu.PC 							= MipsCpu.EntryPointAdd ;	//Start Program At Addr
			MipsCpu.GPR[CPU_REG_GP].lo			= 0x81F80000;				//GP
			MipsCpu.GPR[CPU_REG_SP].lo			= 0x81F00000;				//SP
			MipsCpu.CPR0[12][0]					= 0x10900001;				//Reg Status of COP0
			MipsCpu.CPR0[15][0]					= 0x2E20	;				//Reg PrID of COP0
			MipsCpu.Nb_instructions 			= 0;
			Ps2Bios.NbSema 						= 0;
			
			
			/*
			Create some pointeurs to val for performing the conversion by value of :
			int to float 
			and 
			float to int
			without change the way of store
			for exemple :
				0x4863D000 = 233280.0000
				and not
				0x4863D000 = 1214500864.0000
			*/
			for ( result = 0 ; result < 32 ; result++ ) {
			
			     MipsCpu.FPR1_p_float[result]=(float *)&(MipsCpu.FPR1[result].lo);
   
                }
			
			/*Temp Debug print*/
			printf("Nb Of Prog Section : %ld \n",MipsCpu.NbOfExecutableSection);
			printf("Prog Start Add %lx - End : %lx\n",MipsCpu.OpcodeStartAdd[0],MipsCpu.OpcodeEndAdd[0]); 
			
			
			
			
			if ( INTERPRETER_MODE == 1 ) MipsCpuPrefetchOpcode();
			else {
				MipsCpu.ListPrefetchedOpcode = malloc ( ( sizeof (CpuOpcodePrefetch * )) * 2 );
				if ( MipsCpu.ListPrefetchedOpcode == NULL ) printf("ERROR ALLOC MEM\n");
				
				MipsCpu.ListPrefetchedOpcode[0] = malloc ( sizeof ( CpuOpcodePrefetch ) );
				if ( MipsCpu.ListPrefetchedOpcode[0] == NULL ) printf("ERROR2 ALLOC MEM\n");
				
				printf("ALLOC OK\n\n");
				fflush(stdout);
			}
			
			
			break;
			
		}	

		/* Emulation Start Here...*/
		case 11: {
			/*Change the Idle proc of the Gui*/
            gtk_idle_remove    (nSX2Idle_funcID);
			nSX2Idle_funcID = gtk_idle_add( (GtkFunction)nSX2MainEmuProc ,  NULL );





			
			
			
   
            MipsCpu.halt = 0;
			nsx2InitState = 0;
			
				
			sprintf(tempText,"Start Interpreter....");
			PrintToEmuOutput(tempText);	
			break;
		}
		
		/* MUST NEVER DO THIS */
		default: {
			sprintf(tempText,"Too Bad Muad...");
			PrintToEmuOutput(tempText);	
			break;
		}
		
	}
	
	/* next State when calling again this fucntion */
	nsx2InitState ++;
	
	return TRUE;
}




/*
Main Function of the EMU
*/
int nSX2MainEmuProc (GtkWidget *pWidget, gpointer pData ) {
		
		_u16	boucle;
		// For debugging... 
		//if ( MipsCpu.PC == 0x00404158) debug_op = 1;				//...after acessing a opcode
		//if ( MipsCpu.Nb_instructions > 557000 ) debug_op = 1;		//...after a number of opcode
		
		//if ( MipsCpu.PC == 0x00202930 ) result++;	
		//if ( result == 1 ) debug_op = 1;	
				
	/*
		If the debug mode is running, I can't exec a block of opcode
	
	*/
	
	
	
	switch( MipsCpu.halt ) {

		case 0: 
			if ( debug_op == 0 ) {
				for ( boucle = 0 ; boucle < 1000 ; boucle ++ ) MipsUpdateCpu(); //Execute a Block of opcodes
			} else MipsUpdateCpu();												//Execute the current opcode
			
		break;
		
		case 2:
			MipsUpdateCpu();	//Execute the current opcode
			MipsCpu.halt = 1;	//And Stop
		break;
		
		
	}
	
	/*Execute DMA stuff*/
	DmaUpdate();
	
	/*Execute GS stuff*/
	GSUpdate();
	
	
	/* In future add other stuff like PadUpdate , SoundUpdate , etc.... */
	

	

	if ( Ps2Bios.MustExecHandler == DMA_CH5 ) {
	   //printf(".");
	   if ( ( MipsCpu.PC < Ps2Bios.DmaH[ DMA_CH5 ].Add ) || ( MipsCpu.PC >= Ps2Bios.DmaH[ DMA_CH5 ].EndAdd ) ) {
	   
	       //memcpy( MipsCpu.GPR , Ps2Bios.SaveReg , (sizeof(_u128)) * 34 );
	     
	   
	       MipsCpu.PC = Ps2Bios.DmaH[ DMA_CH5 ].ReturnAdd;
	       Ps2Bios.MustExecHandler =   0xFFFF;
           printf("\nEnd Handler\n");
	       
        }
	  
	
	}
/*	
	if ( MipsCpu.PC == 0x040EB40) {
            debug_op = 1;
            MipsCpu.halt = 1;
            }
*/           	

    ComputeInstructionsPerSec(  );
	
	return TRUE;

}


       /*
        Freq CPU = 300 Mhz
	    436MIPS ( Million of Instruction per Second )
	    436 000 000
	    */

float ComputeInstructionsPerSec( void  ) {

        static _u32	PreviousTime= 0;
        static _u32	PreviousNbInstruction = 0;
        
        _u32	CurrentTime;
        float	InstPerSec;
        
        char temp_string [100];
        
        CurrentTime = SDL_GetTicks();
	
		if ( CurrentTime < PreviousTime ) PreviousTime = 0;
	
		if ( ( CurrentTime - PreviousTime ) > 1000 ) {


			InstPerSec = (float)(( MipsCpu.Nb_instructions - PreviousNbInstruction ) * ( ( CurrentTime - PreviousTime ) / 1000 )) / 1000000.0;

			sprintf(temp_string,"CPU Speed:%10.6f MIPS\n",InstPerSec);

gtk_statusbar_push (GTK_STATUSBAR (StatusBar), GPOINTER_TO_INT(ContextId1), g_locale_to_utf8(temp_string, -1, NULL, NULL, NULL));
	
			PreviousNbInstruction = MipsCpu.Nb_instructions;
			PreviousTime = 	CurrentTime;
		}
}


