/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include <stdlib.h>
#include <stdio.h>
#include <glib.h>


#include "nSX2.h"
#include "PS2Edefs.h"



void GSUpdate( void ) {

	_u128	intc_stat;		//INT_C value
 	
	/*
	if need refresh Screen
	This is done when Reading at 0x12001000 ( r5900_memory.c ) or
	when Interrupt occurs on Counter 4 ( timers_main.c )
	*/	
	if ( Ps2Bios.NeedUpdateScreen == TRUE ) {
   		
		(*GSvsync)();

		/* And I Put an Interrput on VBLANK_E and VBLANK_S */
		MipsMemoryReadW ( SpecialAreaMemory, &intc_stat , (INTC_STAT & 0xFFFF) ) ;	//don't need DMA Check
		intc_stat.lo = intc_stat.lo | ( 0x1 << INTC_VBLANK_E );
		intc_stat.lo = intc_stat.lo | ( 0x1 << INTC_VBLANK_S );
		MipsMemoryWriteW( SpecialAreaMemory, intc_stat.lo, (INTC_STAT & 0xFFFF) );	//don't need DMA Check
		
		/* I don't need to refresh screeen */
		Ps2Bios.NeedUpdateScreen = FALSE;

	}

}









