/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>


#include "nSX2.h"

#include "PS2Edefs.h"


/*
At Adress fBinaryInAddr, note: value(position)
: 80000100(0) 00000000(1) 00000000(2) 00000000(3)
: 003309c0(4) 00000000(5) 00000000(6) 00000000(7)



*/

void RPC_8000010f_PadMan1( _u32 fRPCcommand, _u64 fBinaryInAddr, _u64 fBinaryOutAddr ) {
	char temp_string[100];
	char * tempString;

	
	_u32 * RPC_Pad_Command;
	_u32 * RPC_Pad_Return;


	int port;

	switch ( fRPCcommand ) {
		
		case 0x1:
			RPC_Pad_Command = (  _u32 * ) &MipsMemory [   fBinaryInAddr  & 0x01FFFFFF ];
	
			

			switch( *RPC_Pad_Command ) {

				case PAD_RPCCMD_OPEN:
					if ( debug_print_syscall == 1 ) {
						PrintToBIOSOutput (  "      |_PadMan1_RPCCommand:PAD_RPCCMD_OPEN\n" );
						sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));PrintToBIOSOutput (  temp_string );
						sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));PrintToBIOSOutput (  temp_string );
						sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));PrintToBIOSOutput (  temp_string );
			
					}
					/*
					At Adress fBinaryInAddr, note: value(position)
					for turnip
					: 80000100(0) 00000000(1) 00000000(2) 00000000(3)
					: 003309c0(4) 00000000(5) 00000000(6) 00000000(7)

						0: command
						1: port
						2: slot
						3: return 0:failed  1:OK
						4: addr of Data
				
						Disasm Turnip at address: 0x002060D0					


					*/
						
					port = *(RPC_Pad_Command + 1);

					Ps2Bios.PadData[port][0] = (struct _Pad_Data * ) &MipsMemory [   ((_u32)*(RPC_Pad_Command + 4)) & 0x01FFFFFF ];
					Ps2Bios.PadData[port][1] = (struct _Pad_Data * ) &MipsMemory [   ((_u32)*(RPC_Pad_Command + 4 + sizeof(struct _Pad_Data))) & 0x01FFFFFF ];


					Ps2Bios.PadData[port][1]->frame = 0;
					Ps2Bios.PadData[port][0]->frame = 0;
			
					Ps2Bios.PadData[port][0]->state 		= PAD_STATE_STABLE;
					Ps2Bios.PadData[port][0]->reqState 		= PAD_RSTAT_COMPLETE;
					Ps2Bios.PadData[port][0]->length 		= sizeof(struct _padButtonStatus);

					
	
		
					Ps2Bios.PadState[port] = (struct _padButtonStatus*)Ps2Bios.PadData[port][0]->data;
					Ps2Bios.PadState[port]->btns[0] = 0xff;
					Ps2Bios.PadState[port]->btns[1] = 0xff;

					
					
						

					RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];

					*(RPC_Pad_Return + 3) = 1;
					

				break;

				case PAD_RPCCMD_SET_MMODE:
					if ( debug_print_syscall == 1 ) {
						PrintToBIOSOutput (  "      |_PadMan1_RPCCommand:PAD_RPCCMD_SET_MMODE\n" );
						sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));PrintToBIOSOutput (  temp_string );
						sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));PrintToBIOSOutput (  temp_string );
						sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));PrintToBIOSOutput (  temp_string );
					}
					/*
					At Adress fBinaryInAddr, note: value(position)
					for turnip
       				|Header: 80000105 00000000 00000000 00000001
        			|Header: 00000003 00000000 00000000 00000000
        			|Header: 00000000 00000000 00000000 00000000
	
						0: command
						1: port
						2: slot
						3: Offset in controller mode ID table containing the switched controller mode
						4: Lock/Unlock analog switch 0, 1: keep current lock/unlock status 2: Unlock 3: Lock
						5: return Value

						Disasm Turnip at address: 0x002067C0


					*/
			

					RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];
					*(RPC_Pad_Return + 5 ) = 4; //must not be 1
					
			

				break;

			case PAD_RPCCMD_GET_PORTMAX:
				//bout[12/4] = 2;
				if ( debug_print_syscall == 1 ) {
					PrintToBIOSOutput (  "      |_PadMan1_RPCCommand:PAD_RPCCMD_GET_PORTMAX\n" );
					sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));PrintToBIOSOutput (  temp_string );
					sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));PrintToBIOSOutput (  temp_string );
					sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));PrintToBIOSOutput (  temp_string );
				}
				RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];
				*(RPC_Pad_Return + 3 ) = 2;


			break;

			case PAD_RPCCMD_GET_SLOTMAX:
				//bout[12/4] = 1;
				if ( debug_print_syscall == 1 ) {
					PrintToBIOSOutput (  "      |_PadMan1_RPCCommand:PAD_RPCCMD_GET_SLOTMAX\n" );
					sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));PrintToBIOSOutput (  temp_string );
					sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));PrintToBIOSOutput (  temp_string );
					sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));PrintToBIOSOutput (  temp_string );
				}
				/*
					Disasm Turnip at address: 0x00206650
					0: command
					1: slot
					2: ?? not used
					3: return 

				*/
						
				RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];
				*(RPC_Pad_Return + 3 ) = 1;


			break;

			case PAD_RPCCMD_GET_BTNMASK:
				//bout[12/4] = 1;
				if ( debug_print_syscall == 1 ) {
					PrintToBIOSOutput (  "      |_PadMan1_RPCCommand:PAD_RPCCMD_GET_BTNMASK\n" );
					sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));PrintToBIOSOutput (  temp_string );
					sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));PrintToBIOSOutput (  temp_string );
					sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));PrintToBIOSOutput (  temp_string );
				}			
					/*
					At Adress fBinaryInAddr, note: value(position)
					for turnip

        			|Header: 80000108 00000000 00000000 00000001
        			|Header: 00000003 00000004 00000000 00000000
        			|Header: 00000000 00000000 00000000 00000000

					Disasm Turnip at address: 0x002069E8
					0: command
					1: port
					2: slot
					3: return 
					
					return Checked at 0x002068C0	

					*/



				RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];
				*(RPC_Pad_Return + 3 ) = 0;			// No Pressure-sensitive functions supported
				//*(RPC_Pad_Return + 3 ) = 0x3FFFF;		//Pressure-sensitive functions supported


			break;

			case PAD_RPCCMD_SET_BTNINFO:
				//bout[12/4] = 1;
				if ( debug_print_syscall == 1 ) {
					PrintToBIOSOutput (  "      |_PadMan1_RPCCommand:PAD_RPCCMD_SET_BTNINFO\n" );
					sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command),*(RPC_Pad_Command+1),*(RPC_Pad_Command+2),*(RPC_Pad_Command+3));PrintToBIOSOutput (  temp_string );
					sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+4),*(RPC_Pad_Command+5),*(RPC_Pad_Command+6),*(RPC_Pad_Command+7));PrintToBIOSOutput (  temp_string );
					sprintf(temp_string, "        |Header: %8.8lx %8.8lx %8.8lx %8.8lx\n",*(RPC_Pad_Command+8),*(RPC_Pad_Command+9),*(RPC_Pad_Command+10),*(RPC_Pad_Command+11));PrintToBIOSOutput (  temp_string );
				}			

					/*
					At Adress fBinaryInAddr, note: value(position)
					for turnip

       				|Header: 80000109 00000000 00000000 00000fff
        			|Header: 00000003 00000004 00000000 00000000
        			|Header: 00000000 00000000 00000000 00000000
					
					Disasm Turnip at address: 0x00206AA0
					0: command
					1: port
					2: slot
					3: ???
					4: return 


  					*/



				RPC_Pad_Return = (  _u32 * ) &MipsMemory [   fBinaryOutAddr  & 0x01FFFFFF ];
				*(RPC_Pad_Return + 4 ) = 2;		//Must not be 1


			break;


			default: sprintf(temp_string,"      |PadMan1_RPCCommand:%8.8lx Unknow\n",*RPC_Pad_Command);PrintToBIOSOutput (  temp_string );

			}


	
	

		break;
		
		

		default: sprintf(temp_string,"      |PadMan1Command:%8.8lx Unknow\n",fRPCcommand);PrintToBIOSOutput (  temp_string );

	}


}

