/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>

#include "nSX2.h"
 
#include "r5900_main.h"
#include "r5900_main_table.h"

#include "PS2Edefs.h"
 
/*****************************************************************************************************************
									COP0 INSTRUCTION SET
*****************************************************************************************************************/

void    COP0()	{	cop0_opc[(_OPCODE_ & 0x3E00000)>>21]();}

void	C0() 	{	cop0c0_opc[(_OPCODE_ & 0x3F)](); }


/*
Move from Coprocessor 0
To move the contents of a coprocessor 0 register to a general register.
MIPS32
*/
void   	MF0() {
	if ( debug_op == 1 ) sprintf(debugTempText,"%8.8llx: mfc0 %s,%s,%ld", (long)MipsCpu.PC, debug_r5900_reg[CURRENT_RT],debug_r5900_cop0_reg[CURRENT_RD],CURRENT_SEL );
	
	MipsCpu.GPR[CURRENT_RT].lo = MipsCpu.CPR0[CURRENT_RD][CURRENT_SEL];

	INCREMENT_PC();
}


void   	MT0() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;}

void 	BC0()	{	PrintDebugOpcode() ; MipsCpu.halt = 1;}

void	TLBR() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;}

void	TLBWI() {	PrintDebugOpcode() ; MipsCpu.halt = 1;}

void	TLBWR() {	PrintDebugOpcode() ; MipsCpu.halt = 1;}

void	TLBP() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;}

void	ERET() 	{	PrintDebugOpcode() ; MipsCpu.halt = 1;}


void 	EI() 	{
	MipsCpu.CPR0[12][0]	=	MipsCpu.CPR0[12][0]  | 0x00010000;
	INCREMENT_PC();
}



void 	DI() 	{
	MipsCpu.CPR0[12][0]	=	MipsCpu.CPR0[12][0]  & 0xFFFEFFFF;
	INCREMENT_PC();
}


