#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>

#include "nSX2.h"
 
#include "r5900_main.h"
#include "r5900_main_table.h"

#include "r5900_cop2_vu_opcodes.h"

/*****************************************************************************************************************
									COP2 INSTRUCTION SET
*****************************************************************************************************************/

void COP2()			{	cop2_opc[((_OPCODE_)&0x3E00000)>>21]();		}


void Vopc_t60( )	{ 	cop2_V_t60_opc[((_OPCODE_)&0x7C0)>>6]();	} 

void Vopc_t61( )	{ 	cop2_V_t61_opc[((_OPCODE_)&0x7C0)>>6]();	} 

void Vopc_t62( )	{ 	cop2_V_t62_opc[((_OPCODE_)&0x7C0)>>6]();	} 
 
void Vopc_t63( )	{ 	cop2_V_t63_opc[((_OPCODE_)&0x7C0)>>6](); 	} 
 

/*
*/
void    LQC2()		{	
	_u128	temp128;
	_u64 off;
	
	off = Extractoffset();
	sign_extendedh(off);

	if ( debug_op == 1 ) 	sprintf(debugTempText,"%8.8llx: lqc2 VUfp%ld,%4llx(%s)", (long)MipsCpu.PC, CURRENT_FT,CURRENT_OFFSET,debug_r5900_reg[CURRENT_BASE] );

	MipsMemoryRead ( &temp128 , DATA_QUAD ,  MipsCpu.GPR[CURRENT_BASE].lo , off ) ;

	VectorUnit0.CPR[CURRENT_FT][0] = (_u32)(temp128.lo);
	VectorUnit0.CPR[CURRENT_FT][1] = (_u32)((_u64)temp128.lo >> 32 );
	VectorUnit0.CPR[CURRENT_FT][2] = (_u32)(temp128.hi) ;
	VectorUnit0.CPR[CURRENT_FT][3] = (_u32)((_u64)temp128.hi >> 32 );
	
	INCREMENT_PC();

}

/*
*/
void    SQC2()		{	
	_u128	temp128;
	_u64 off;

	off = Extractoffset();
	sign_extendedh(off);

	if ( debug_op == 1 ) 	sprintf(debugTempText,"%8.8llx: lqc2 VUfp%ld,%4llx(%s)", (long)MipsCpu.PC, CURRENT_FT,CURRENT_OFFSET,debug_r5900_reg[CURRENT_BASE] );

	temp128.lo = VectorUnit0.CPR[CURRENT_FT][0] | ( (_u64)VectorUnit0.CPR[CURRENT_FT][1] << 32 );
	temp128.hi = VectorUnit0.CPR[CURRENT_FT][2] | ( (_u64)VectorUnit0.CPR[CURRENT_FT][3] << 32 );

	MipsMemoryWrite ( temp128 , DATA_QUAD ,  MipsCpu.GPR[CURRENT_BASE].lo , off ) ;
	
	INCREMENT_PC();
}



/*
*/
void cop2_QMFC2() {
	if ( debug_op == 1 ) 	sprintf(debugTempText,"%8.8llx: qmfc2", (long)MipsCpu.PC );

	MipsCpu.GPR[CURRENT_RT].lo = VectorUnit0.CPR[CURRENT_FS][0] |  (_u64)((_u64)VectorUnit0.CPR[CURRENT_FS][1] << 32 );
	MipsCpu.GPR[CURRENT_RT].hi = VectorUnit0.CPR[CURRENT_FS][2] |  (_u64)((_u64)VectorUnit0.CPR[CURRENT_FS][3] << 32 );

	INCREMENT_PC();

}



/*
CFC2
Transfer Integer Data From VU to EE Core
*/
void cop2_CFC2() {
	if ( debug_op == 1 ) 	sprintf(debugTempText,"%8.8llx: cfc2 %s, %s", (long)MipsCpu.PC,debug_r5900_reg[CURRENT_RT] , debug_vu_ccr_reg[CURRENT_ID] ); 
	
	MipsCpu.GPR[CURRENT_RT].lo = VectorUnit0.CCR[ CURRENT_ID ] ;

	INCREMENT_PC();
}



/*
QMTC2 : Floating-Point Data Transfert from EE to VU
*/
void cop2_QMTC2( ) {
	if ( debug_op == 1 ) 	sprintf(debugTempText,"%8.8llx: qmtc2 %s, vf%2.2d", (long)MipsCpu.PC,debug_r5900_reg[CURRENT_RT] , CURRENT_FS );

	VectorUnit0.CPR[CURRENT_FS][0] = (_u32)(MipsCpu.GPR[CURRENT_RT].lo);
	VectorUnit0.CPR[CURRENT_FS][1] = (_u32)((_u64)MipsCpu.GPR[CURRENT_RT].lo >> 32 );
	VectorUnit0.CPR[CURRENT_FS][2] = (_u32)(MipsCpu.GPR[CURRENT_RT].hi );
	VectorUnit0.CPR[CURRENT_FS][3] = (_u32)((_u64)MipsCpu.GPR[CURRENT_RT].hi >> 32 );
	
	INCREMENT_PC();
}


/*
Transfer Integer Data From EE Core to VU
*/
void cop2_CTC2	() {
	if ( debug_op == 1 ) 	sprintf(debugTempText,"%8.8llx: ctc2 %s, %s", (long)MipsCpu.PC,debug_r5900_reg[CURRENT_RT] , debug_vu_ccr_reg[CURRENT_ID] ); 

	VectorUnit0.CCR[ CURRENT_ID ] = (_u32)MipsCpu.GPR[CURRENT_RT].lo ;

	INCREMENT_PC();
}


/*	

*/
void cop2_BC() { 	PrintDebugOpcode() ; MipsCpu.halt = 1;}


/*****************************************************************************************************************
									COP0 VU0 INSTRUCTION SET
*****************************************************************************************************************/

void cop2_Vopc() { cop2_V_opc[((_OPCODE_)&0x3F)](); } 


/*
*/
void VADDbc( ){

	vuADDbc(VectorUnit0);
	INCREMENT_PC();
} 
 

void VSUBbc( )	{ PrintDebugOpcode() ; MipsCpu.halt = 1;	} 
 
/*
*/
void VMADDbc( )	{ 
	vuMADDbc(VectorUnit0);
	INCREMENT_PC();
} 


void VMSUBbc()	{	PrintDebugOpcode() ; MipsCpu.halt = 1;} 

 

void VMAXbc()	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;} 

 

void VMINIbc()	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 


void VMULbc( ){
	vuMULbc(VectorUnit0);
	INCREMENT_PC();
} 
 

void VMULq( )	{ 	
	vuMULq(VectorUnit0);
	INCREMENT_PC();
} 



void VMAXi( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 



void VMULi( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1; } 


 
void VMINIi( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 




void VADDq( )	{ 	
	vuADDq(VectorUnit0);
	INCREMENT_PC();
} 

 

void VMADDq( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 



void VADDi( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;} 


void VMADDi( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 


void VSUBq( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 


void VMSUBq( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;} 

 

void VSUBi( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 


void VMSUBi( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1; }

 

void VADD( ){ 
	vuADD(VectorUnit0);
	INCREMENT_PC();
} 



void VMADD( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 



void VMUL( ){
	vuMUL(VectorUnit0);
	INCREMENT_PC();
} 


void VMAX( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 



void VSUB( )	{ 	
	vuSUB(VectorUnit0);
	INCREMENT_PC();
} 



void VMSUB( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 



void VOPMSUB( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 



void VMINI( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;} 



void VIADD( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 

 

void VISUB( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 


 
void VIADDI( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 
 
 

void VIAND( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 


 
void VIOR( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 

 
void VCALLMS( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1; } 


void VCALLMSR( ){ 	PrintDebugOpcode() ; MipsCpu.halt = 1; } 
 

 

/*******************************************************************/


void VADDAbc( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 

 
 
void VSUBAbc( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  

  

void VMADDAbc( ){  
	vuMADDAbc(VectorUnit0)
	INCREMENT_PC();
}


void VMSUBAbc( ){ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 



/*******************************************************************/  

void VITOF12( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  

  

void VFTOI12( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  

  

void VMULAbc( ){ 
	vuMULAbc(VectorUnit0);
	INCREMENT_PC();
}



void VMULAi( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  

 

void VADDAi( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  

  

void VSUBAi( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  

  

void VMULA( )	{	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  

  

void VOPMULA( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  

 


void VLQD( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	 }  

  

void VRSQRT( ){
	vuRSQRT(VectorUnit0);
	INCREMENT_PC();
}  


  

void VILWR( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  

  

void VRINIT( ){
	vuRINIT(VectorUnit0)
	INCREMENT_PC();
}  		


/***********************************************************************************************/

#define VU_FLOAT_TO_INTEGER_0(val) (_s32)(float)(val)

void VITOF0( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  



void VFTOI0( ){ 
	vuFTOI0(VectorUnit0);
	INCREMENT_PC();	
}  


void VMULAq( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  


void VADDAq( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  

 
void VSUBAq( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  


void VADDA( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  
 

void VSUBA( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  

 
void VMOVE( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}   


void VLQI( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}   
 

void VDIV( )	{ 
	vuDIV(VectorUnit0);
	INCREMENT_PC();
}  

void VMTIR( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}   


void VRNEXT( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}  
 




void VITOF4( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}
 
 
void VFTOI4( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}

 
void VABS( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}

 
void VMADDAq( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 


void VMSUBAq( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 


void VMADDA( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}

 
void VMSUBA( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}

 
void VMR32( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 
 

void VSQI( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}

 
void VSQRT( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}


void VMFIR( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}

 
void VRGET	( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 	




/*************************************************************************/


void VITOF15( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}


void VFTOI15( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}


void VCLIP( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}


void VMADDAi( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	}


void VMSUBAi( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 


void VNOP( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 


void VSQD( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 


/*
*/
void VWAITQ( )	{ 	
	vuWAITQ(VectorUnit0);	
	INCREMENT_PC();	
} 



void VISWR( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 


void VRXOR	( )	{ 	PrintDebugOpcode() ; MipsCpu.halt = 1;	} 	





