/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

/*
NOTA:

the vu Micro and Macro opcodes are the same
Write only time
param ( not really one ) is the VU which execute the opcode
*/




#define vuADDbc(VectorUnit) {  \
if ( CURRENT_DEST  & 0x1 ) *(VectorUnit.CPR_p_float[CURRENT_FD][0]) = *(VectorUnit.CPR_p_float[CURRENT_FS][0]) + *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC]); \
if ( CURRENT_DEST  & 0x2 ) *(VectorUnit.CPR_p_float[CURRENT_FD][1]) = *(VectorUnit.CPR_p_float[CURRENT_FS][1]) + *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC]); \
if ( CURRENT_DEST  & 0x4 ) *(VectorUnit.CPR_p_float[CURRENT_FD][2]) = *(VectorUnit.CPR_p_float[CURRENT_FS][2]) + *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC]); \
if ( CURRENT_DEST  & 0x8 ) *(VectorUnit.CPR_p_float[CURRENT_FD][3]) = *(VectorUnit.CPR_p_float[CURRENT_FS][3]) + *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC]); \
} 



#define vuMADDbc(VectorUnit) { \
if ( CURRENT_DEST  & 0x1 ) *(VectorUnit.CPR_p_float[CURRENT_FD][0]) = *(VectorUnit.ACC_p_float[0]) + (*(VectorUnit.CPR_p_float[CURRENT_FS][0]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC])); \
if ( CURRENT_DEST  & 0x2 ) *(VectorUnit.CPR_p_float[CURRENT_FD][1]) = *(VectorUnit.ACC_p_float[1]) + (*(VectorUnit.CPR_p_float[CURRENT_FS][1]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC])); \
if ( CURRENT_DEST  & 0x4 ) *(VectorUnit.CPR_p_float[CURRENT_FD][2]) = *(VectorUnit.ACC_p_float[2]) + (*(VectorUnit.CPR_p_float[CURRENT_FS][2]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC])); \
if ( CURRENT_DEST  & 0x8 ) *(VectorUnit.CPR_p_float[CURRENT_FD][3]) = *(VectorUnit.ACC_p_float[3]) + (*(VectorUnit.CPR_p_float[CURRENT_FS][3]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC])); \
}


#define vuMULbc(VectorUnit) { \
if ( CURRENT_DEST  & 0x1 ) *(VectorUnit.CPR_p_float[CURRENT_FD][0]) = *(VectorUnit.CPR_p_float[CURRENT_FS][0]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC]); \
if ( CURRENT_DEST  & 0x2 ) *(VectorUnit.CPR_p_float[CURRENT_FD][1]) = *(VectorUnit.CPR_p_float[CURRENT_FS][1]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC]); \
if ( CURRENT_DEST  & 0x4 ) *(VectorUnit.CPR_p_float[CURRENT_FD][2]) = *(VectorUnit.CPR_p_float[CURRENT_FS][2]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC]); \
if ( CURRENT_DEST  & 0x8 ) *(VectorUnit.CPR_p_float[CURRENT_FD][3]) = *(VectorUnit.CPR_p_float[CURRENT_FS][3]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC]); \
}


#define vuADD(VectorUnit) { \
if ( CURRENT_DEST  & 0x1 ) *(VectorUnit.CPR_p_float[CURRENT_FD][0]) = *(VectorUnit.CPR_p_float[CURRENT_FS][0]) + *(VectorUnit.CPR_p_float[CURRENT_FT][0]); \
if ( CURRENT_DEST  & 0x2 ) *(VectorUnit.CPR_p_float[CURRENT_FD][1]) = *(VectorUnit.CPR_p_float[CURRENT_FS][1]) + *(VectorUnit.CPR_p_float[CURRENT_FT][1]); \
if ( CURRENT_DEST  & 0x4 ) *(VectorUnit.CPR_p_float[CURRENT_FD][2]) = *(VectorUnit.CPR_p_float[CURRENT_FS][2]) + *(VectorUnit.CPR_p_float[CURRENT_FT][2]); \
if ( CURRENT_DEST  & 0x8 ) *(VectorUnit.CPR_p_float[CURRENT_FD][3]) = *(VectorUnit.CPR_p_float[CURRENT_FS][3]) + *(VectorUnit.CPR_p_float[CURRENT_FT][3]); \
}


#define vuMUL(VectorUnit) { \
if ( CURRENT_DEST  & 0x1 ) *(VectorUnit.CPR_p_float[CURRENT_FD][0]) = *(VectorUnit.CPR_p_float[CURRENT_FS][0]) * *(VectorUnit.CPR_p_float[CURRENT_FT][0]); \
if ( CURRENT_DEST  & 0x2 ) *(VectorUnit.CPR_p_float[CURRENT_FD][1]) = *(VectorUnit.CPR_p_float[CURRENT_FS][1]) * *(VectorUnit.CPR_p_float[CURRENT_FT][1]); \
if ( CURRENT_DEST  & 0x4 ) *(VectorUnit.CPR_p_float[CURRENT_FD][2]) = *(VectorUnit.CPR_p_float[CURRENT_FS][2]) * *(VectorUnit.CPR_p_float[CURRENT_FT][2]); \
if ( CURRENT_DEST  & 0x8 ) *(VectorUnit.CPR_p_float[CURRENT_FD][3]) = *(VectorUnit.CPR_p_float[CURRENT_FS][3]) * *(VectorUnit.CPR_p_float[CURRENT_FT][3]); \
}


#define vuMADDAbc(VectorUnit) {  \
if ( CURRENT_DEST  & 0x1 ) *(VectorUnit.ACC_p_float[0]) = *(VectorUnit.ACC_p_float[0]) + (*(VectorUnit.CPR_p_float[CURRENT_FS][0]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC])); \
if ( CURRENT_DEST  & 0x2 ) *(VectorUnit.ACC_p_float[1]) = *(VectorUnit.ACC_p_float[1]) + (*(VectorUnit.CPR_p_float[CURRENT_FS][1]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC])); \
if ( CURRENT_DEST  & 0x4 ) *(VectorUnit.ACC_p_float[2]) = *(VectorUnit.ACC_p_float[2]) + (*(VectorUnit.CPR_p_float[CURRENT_FS][2]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC])); \
if ( CURRENT_DEST  & 0x8 ) *(VectorUnit.ACC_p_float[3]) = *(VectorUnit.ACC_p_float[3]) + (*(VectorUnit.CPR_p_float[CURRENT_FS][3]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC])); \
}


#define vuMULAbc(VectorUnit) { \
if ( CURRENT_DEST  & 0x1 ) *(VectorUnit.ACC_p_float[0]) = *(VectorUnit.CPR_p_float[CURRENT_FS][0]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC]); \
if ( CURRENT_DEST  & 0x2 ) *(VectorUnit.ACC_p_float[1]) = *(VectorUnit.CPR_p_float[CURRENT_FS][1]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC]); \
if ( CURRENT_DEST  & 0x4 ) *(VectorUnit.ACC_p_float[2]) = *(VectorUnit.CPR_p_float[CURRENT_FS][2]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC]); \
if ( CURRENT_DEST  & 0x8 ) *(VectorUnit.ACC_p_float[3]) = *(VectorUnit.CPR_p_float[CURRENT_FS][3]) * *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_BC]); \
}


#define vuRSQRT(VectorUnit){ \
*(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]) =  ( *(VectorUnit.CPR_p_float[CURRENT_FS][CURRENT_FSF]) / sqrt(*(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_FTF]) ) );\
}

#define vuRINIT(VectorUnit){ \
VectorUnit.CCR[ VU_R_REGISTER ] = ( VectorUnit.CPR[CURRENT_FS][CURRENT_FSF] & 0x7FFFFF ); \
}


#define vuFTOI0(VectorUnit){ \
if ( CURRENT_DEST  & 0x1 ) *(VectorUnit.CPR_p_float[CURRENT_FT][0]) = VU_FLOAT_TO_INTEGER_0(*(VectorUnit.CPR_p_float[CURRENT_FS][0])) ; \
if ( CURRENT_DEST  & 0x2 ) *(VectorUnit.CPR_p_float[CURRENT_FT][1]) = VU_FLOAT_TO_INTEGER_0(*(VectorUnit.CPR_p_float[CURRENT_FS][1])) ; \
if ( CURRENT_DEST  & 0x4 ) *(VectorUnit.CPR_p_float[CURRENT_FT][2]) = VU_FLOAT_TO_INTEGER_0(*(VectorUnit.CPR_p_float[CURRENT_FS][2])) ; \
if ( CURRENT_DEST  & 0x8 ) *(VectorUnit.CPR_p_float[CURRENT_FT][3]) = VU_FLOAT_TO_INTEGER_0(*(VectorUnit.CPR_p_float[CURRENT_FS][3])) ; \
}

#define vuDIV(VectorUnit){ \
*(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]) =  ( *(VectorUnit.CPR_p_float[CURRENT_FS][CURRENT_FSF]) / *(VectorUnit.CPR_p_float[CURRENT_FT][CURRENT_FTF])  ); \
}

#define vuWAITQ(VectorUnit) { }

#define vuMULq(VectorUnit) { \
if ( CURRENT_DEST  & 0x1 ) *(VectorUnit.CPR_p_float[CURRENT_FD][0]) = *(VectorUnit.CPR_p_float[CURRENT_FS][0]) * *(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]); \
if ( CURRENT_DEST  & 0x2 ) *(VectorUnit.CPR_p_float[CURRENT_FD][1]) = *(VectorUnit.CPR_p_float[CURRENT_FS][1]) * *(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]); \
if ( CURRENT_DEST  & 0x4 ) *(VectorUnit.CPR_p_float[CURRENT_FD][2]) = *(VectorUnit.CPR_p_float[CURRENT_FS][2]) * *(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]); \
if ( CURRENT_DEST  & 0x8 ) *(VectorUnit.CPR_p_float[CURRENT_FD][3]) = *(VectorUnit.CPR_p_float[CURRENT_FS][3]) * *(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]); \
}


#define vuSUB(VectorUnit) { \
if ( CURRENT_DEST  & 0x1 ) *(VectorUnit.CPR_p_float[CURRENT_FD][0]) = *(VectorUnit.CPR_p_float[CURRENT_FS][0]) - *(VectorUnit.CPR_p_float[CURRENT_FT][0]); \
if ( CURRENT_DEST  & 0x2 ) *(VectorUnit.CPR_p_float[CURRENT_FD][1]) = *(VectorUnit.CPR_p_float[CURRENT_FS][1]) - *(VectorUnit.CPR_p_float[CURRENT_FT][1]); \
if ( CURRENT_DEST  & 0x4 ) *(VectorUnit.CPR_p_float[CURRENT_FD][2]) = *(VectorUnit.CPR_p_float[CURRENT_FS][2]) - *(VectorUnit.CPR_p_float[CURRENT_FT][2]); \
if ( CURRENT_DEST  & 0x8 ) *(VectorUnit.CPR_p_float[CURRENT_FD][3]) = *(VectorUnit.CPR_p_float[CURRENT_FS][3]) - *(VectorUnit.CPR_p_float[CURRENT_FT][3]); \
}


#define vuADDq(VectorUnit) { \
if ( CURRENT_DEST  & 0x1 ) *(VectorUnit.CPR_p_float[CURRENT_FD][0]) = *(VectorUnit.CPR_p_float[CURRENT_FS][0]) + *(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]); \
if ( CURRENT_DEST  & 0x2 ) *(VectorUnit.CPR_p_float[CURRENT_FD][1]) = *(VectorUnit.CPR_p_float[CURRENT_FS][1]) + *(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]); \
if ( CURRENT_DEST  & 0x4 ) *(VectorUnit.CPR_p_float[CURRENT_FD][2]) = *(VectorUnit.CPR_p_float[CURRENT_FS][2]) + *(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]); \
if ( CURRENT_DEST  & 0x8 ) *(VectorUnit.CPR_p_float[CURRENT_FD][3]) = *(VectorUnit.CPR_p_float[CURRENT_FS][3]) + *(VectorUnit.CCR_p_float[ VU_Q_REGISTER ]); \
}








