/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#ifndef _R5900_MAIN_H
#define _R5900_MAIN_H

//From Hacktarux
#define sign_extended(a) if (a & 0x0000000080000000LL) a |= 0xFFFFFFFF00000000LL; else a &= 0xFFFFFFFF
#define sign_extendedb(a) if (a & 0x80) a |= 0xFFFFFFFFFFFFFF00LL; else a &= 0xFF
#define sign_extendedh(a) if (a & 0x8000) a |= 0xFFFFFFFFFFFF0000LL; else a &= 0xFFFF







// Increment the PC 
#define INCREMENT_PC() MipsCpu.PC = MipsCpu.PC + 4
 
// Read the Memory at PC value
#define MipsFillOpcode(A) MipsCpu.opcode=*( (_u64 *) (( _u8 *)( MipsMemory + A ) ))

// Ease the code
#define		_OPCODE_				MipsCpu.opcode

//This macro decode the memory and Fill the opcode field of the cpu
#define		CURRENT_RT				(((_OPCODE_)& 0x1F0000)>>16)
#define		CURRENT_RS				(((_OPCODE_)& 0x3E00000)>>21)
#define		CURRENT_RD				(((_OPCODE_)& 0xF800)>>11)
#define		CURRENT_BASE			(((_OPCODE_)& 0x3E00000)>>21)
#define		CURRENT_SA				(((_OPCODE_)& 0x7C0)>>6)
#define		CURRENT_IMM				(((_OPCODE_)& 0xFFFF))
#define		CURRENT_OFFSET			(((_OPCODE_)& 0xFFFF))
#define		CURRENT_INSTR_INDEX		(((_OPCODE_)& 0x3FFFFFF))
#define		CURRENT_SEL				(((_OPCODE_)& 0x7))
#define		CURRENT_FT				(((_OPCODE_)& 0x1F0000)>>16)
#define		CURRENT_FD				(((_OPCODE_)& 0x7C0)>>6)
#define		CURRENT_FS				(((_OPCODE_)& 0xF800)>>11)
#define		CURRENT_CC				(((_OPCODE_)& 0x700)>>8)
#define		CURRENT_CCB				(((_OPCODE_)& 0x1C0000)>>18)

#define		CURRENT_ID				(((_OPCODE_)& 0xF800)>>11 )
#define		CURRENT_FSF				(((_OPCODE_)& 0x600000)>>21)
#define		CURRENT_FTF				(((_OPCODE_)& 0x1800000)>>23)
#define		CURRENT_BC				(((_OPCODE_)& 0x3))
#define		CURRENT_DEST			(((_OPCODE_)& 0x1E00000)>>21)

char debugTempText[100];
char debugTempOpcodeText[100];


/*
Macro to extract the field of the Opcode
*/
#define Extractrt() 			CURRENT_RT	
#define Extractrs() 			CUURENT_RS
#define Extractbase() 			CURRENT_BASE	
#define Extractimm() 			CURRENT_IMM
#define Extractoffset() 		CURRENT_OFFSET
#define Extractrd() 			CURRENT_RD	
#define Extractinstr_index() 	CURRENT_INSTR_INDEX
#define Extractsa() 			CURRENT_SA	
#define Extractsel() 			CURRENT_SEL	

#define Extractft() 			CURRENT_FT	
#define Extractfd() 			CURRENT_FD	
#define Extractfs() 			CURRENT_FS
#define Extractcc() 			CURRENT_CC
#define Extractccb() 			CURRENT_CCB


#define Extractid() 			CURRENT_ID
#define ExtractCop2fsf()		CURRENT_FSF
#define ExtractCop2ftf()		CURRENT_FTF

#define ExtractCop2bc()			CURRENT_BC

#define ExtractCop2dest()		CURRENT_DEST


_u8 IsSignExtended( _u64 fval );
_u8 IsNot32bitIntegerOverflow ( _u64  fval);
_u8 IsNot64bitIntegerOverflow ( _u64  fval);

/*Old Version - _u64 off must be decare before */
#define		CalculTargetBranch2				off = Extractoffset();\
											sign_extendedh(off); \
											off = ( off << 2 ) + 4; \
											target_branch = MipsCpu.PC  +  off 


/* new version */
#define		CalculTargetBranch	target_branch = MipsCpu.PC+(((_s16) CURRENT_OFFSET << 2 ) + 4 )





void NOP		();

void SPECIAL	();
void REGIMM		();
void J			();
void JAL		(); 
void BEQ		(); 
void BNE		(); 
void BLEZ		(); 
void BGTZ		();
void ADDI		(); 
void ADDIU		(); 
void SLTI		(); 
void SLTIU		(); 
void ANDI		(); 
void ORI		(); 
void XORI		(); 
void LUI		();
void COP0		(); 
void COP1		(); 
void COP2		();

void BEQL		(); 
void BNEL		(); 
void BLEZL		(); 
void BGTZL		();
void DADDI		(); 
void DADDIU		(); 
void LDL		(); 
void LDR		(); 
void SPECIAL2	(); 

void LQ			();
void MDMX		(); 
void NI			();
void LB			(); 
void LH			(); 
void LWL		(); 
void LW			(); 
void LBU		(); 
void LHU		(); 
void LWR		(); 
void LWU		();
void SB			(); 
void SH			(); 
void SWL		(); 
void SW			(); 
void SDL		(); 
void SDR		(); 
void SWR		(); 
void CACHE		();

void LWC1		(); 

void PREF		(); 

 
void LQC2		(); 
void LD			();
 
void SWC1		(); 

void SQ			(); 


void SQC2		(); 
void SD			();


void SLL		(); 

void SRL		(); 
void SRA		(); 
void SLLV		(); 
void SRLV		(); 
void SRAV		();
void JR			(); 
void JALR		(); 
void MOVZ		(); 
void MOVN		(); 
void SYSCALL	(); 
void BREAK		(); 
void SYNC		();
void MFHI		(); 
void MTHI		(); 
void MFLO		(); 
void MTLO		(); 
void DSLLV		(); 
void DSRLV		(); 
void DSRAV		();
void MULT		(); 
void MULTU		(); 
void DIV		(); 
void DIVU		(); 

/*
void DMULT		(); 
void DMULTU		(); 
void DDIV		(); 
void DDIVU		();
*/
void ADD		(); 
void ADDU		(); 
void SUB		(); 
void SUBU		(); 
void AND		(); 
void OR			(); 
void XOR		(); 
void NOR		();
void MFSA		(); 
void MTSA		(); 
void SLT		(); 
void SLTU		(); 
void DADD		(); 
void DADDU		(); 
void DSUB		(); 
void DSUBU		();
void TGE		(); 
void TGEU		(); 
void TLT		(); 
void TLTU		(); 
void TEQ		(); 
void TNE		(); 
void DSLL		(); 
void DSRL		(); 
void DSRA		(); 
void DSLL32		(); 
void DSRL32		(); 
void DSRA32		();

void BLTZ(); 
void BGEZ(); 
void BLTZL   (); 
void BGEZL  (); 
void TGEI   (); 
void TGEIU (); 
void TLTI(); 
void TLTIU(); 
void TEQI(); 
void TNEI (); 
void BLTZAL   (); 
void BGEZAL  (); 
void BLTZALL  (); 
void BGEZALL  ();
void MTSAB  ();
void MTSAH  ();


void MF0  ();

void MT0  ();

void C0   ();
void BC0 ();

void TLBR(); 	
void TLBWI();
void TLBWR();	
void TLBP();		
void ERET(); 
	 

void EI(); 	
void DI(); 	
	  
void SYSCALL_RFU000_FullReset( );
void SYSCALL_ResetEE( );
void SYSCALL_SetGsCrt( );
void SYSCALL_RFU003( );
void SYSCALL_Exit( );
void SYSCALL_RFU005( );
void SYSCALL_LoadPS2Exe( );
void SYSCALL_ExecPS2( );
void SYSCALL_RFU008( );
void SYSCALL_RFU009( );
void SYSCALL_AddSbusIntcHandler( );
void SYSCALL_RemoveSbusIntcHandler( );
void SYSCALL_Interrupt2Iop( );
void SYSCALL_SetVTLBRefillHandler( );
void SYSCALL_SetVCommonHandler( );
void SYSCALL_SetVInterruptHandler( );
void SYSCALL_AddIntcHandler( );
void SYSCALL_RemoveIntcHandler( );
void SYSCALL_AddDmacHandler( );
void SYSCALL_RemoveDmacHandler( );
void SYSCALL__EnableIntc( );
void SYSCALL__DisableIntc( );
void SYSCALL__EnableDmac( );
void SYSCALL__DisableDmac( );
void SYSCALL__SetAlarm( );
void SYSCALL__ReleaseAlarm( );
void SYSCALL_NI( );
void SYSCALL_CreateThread( );
void SYSCALL_DeleteThread( );
void SYSCALL_StartThread( );
void SYSCALL_ExitThread( );
void SYSCALL_ExitDeleteThread( );
void SYSCALL_TerminateThread( );
void SYSCALL_DisableDispatchThread( );
void SYSCALL_EnableDispatchThread( );
void SYSCALL_ChangeThreadPriority( );
void SYSCALL_RotateThreadReadyQueue( );
void SYSCALL_ReleaseWaitThread( );
void SYSCALL_GetThreadId( );
void SYSCALL_ReferThreadStatus( );
void SYSCALL_SleepThread( );
void SYSCALL_WakeupThread( );
void SYSCALL_CancelWakeupThread( );
void SYSCALL_SuspendThread( );
void SYSCALL_ResumeThread( );
void SYSCALL_JoinThread( );
void SYSCALL_RFU060( );
void SYSCALL_RFU061( );
void SYSCALL_EndOfHeap( );
void SYSCALL_RFU063( );
void SYSCALL_CreateSema( );
void SYSCALL_DeleteSema( );
void SYSCALL_SignalSema( );
void SYSCALL_WaitSema( );
void SYSCALL_PollSema( );
void SYSCALL_ReferSemaStatus( );
void SYSCALL_RFU073( );
void SYSCALL_SetOsdConfigParam( );
void SYSCALL_GetOsdConfigParam( );
void SYSCALL_GetGsHParam( );
void SYSCALL_GetGsVParam( );
void SYSCALL_SetGsHParam( );
void SYSCALL_SetGsVParam( );
void SYSCALL_RFU080_CreateEventFlag( );
void SYSCALL_RFU081_DeleteEventFlag( );
void SYSCALL_RFU082_SetEventFlag( );
void SYSCALL_RFU083_iSetEventFlag( );
void SYSCALL_RFU084_ClearEventFlag( );
void SYSCALL_RFU085_iClearEventFlag( );
void SYSCALL_RFU086_WaitEvnetFlag( );
void SYSCALL_RFU087_PollEvnetFlag( );
void SYSCALL_RFU088_iPollEvnetFlag( );
void SYSCALL_RFU089_ReferEventFlagStatus( );
void SYSCALL_RFU091( );
void SYSCALL_EnableIntcHandler( );
void SYSCALL_DisableIntcHandler( );
void SYSCALL_EnableDmacHandler( );
void SYSCALL_DisableDmacHandler( );
void SYSCALL_KSeg0( );
void SYSCALL_EnableCache( );
void SYSCALL_DisableCache( );
void SYSCALL_GetCop0( );
void SYSCALL_FlushCache( );
void SYSCALL_CpuConfig( );
void SYSCALL_sceSifStopDma( );
void SYSCALL_SetCPUTimerHandler( );
void SYSCALL_SetCPUTimer( );
void SYSCALL_ForceRead( );
void SYSCALL_ForceWrite( );
void SYSCALL_GsGetIMR( );
void SYSCALL_GsPutIMR( );
void SYSCALL_SetPgifHandler( );
void SYSCALL_SetVSyncFlag( );
void SYSCALL_RFU116( );
void SYSCALL_print( );
void SYSCALL_sceSifDmaStat( );
void SYSCALL_sceSifSetDma( );
void SYSCALL_sceSifSetDChain( );
void SYSCALL_sceSifSetReg( );
void SYSCALL_sceSifGetReg( );
void SYSCALL_ExecOSD( );
void SYSCALL_Deci2Call( );
void SYSCALL_PSMode( );
void SYSCALL_MachineType( );
void SYSCALL_GetMemorySize( );
void SYSCALL_isceSifSetDChain( );
void SYSCALL_isceSifSetDma( );
void SYSCALL_isceSifDmaStat( );
void SYSCALL_iGsPutIMR( );
void SYSCALL_iGsGetIMR( );
void SYSCALL_iCpuConfig( );
void SYSCALL_iFlushCache( );
void SYSCALL_iGetCop0( );
void SYSCALL_iDisableDmacHandler( );
void SYSCALL_iEnableDmacHandler( );
void SYSCALL_iDisableIntcHandler( );
void SYSCALL_iEnableIntcHandler( );
void SYSCALL_RFU090_iReferEventFlagStatus( );
void SYSCALL_iReferSemaStatus( );
void SYSCALL_iPollSema( );
void SYSCALL_iSignalSema( );
void SYSCALL_iResumeThread( );
void SYSCALL_iSuspendThread( );
void SYSCALL_iCancelWakeupThread( );
void SYSCALL_iWakeupThread( );
void SYSCALL_iReferThreadStatus( );
void SYSCALL_iReleaseWaitThread( );
void SYSCALL_iRotateThreadReadyQueue( );
void SYSCALL_iChangeThreadPriority( );
void SYSCALL_iTerminateThread( );
void SYSCALL__iReleaseAlarm( );
void SYSCALL__iSetAlarm( );
void SYSCALL__iDisableDmac( );
void SYSCALL__iEnableDmac( );
void SYSCALL__iDisableIntc( );
void SYSCALL__iEnableIntc( );
void SYSCALL_UKN_1();
void SYSCALL_RFU101_105();
void SYSCALL_SetOsdConfigParam2();

void MADD( );
		
void MADDU( );

void MULT1( );
void PLZCW( );
void MMI0 ();
void MMI2 ();
void MFHI1();
void MTHI1();
void MFLO1();
void MTLO1();

void MULTU1();
void DIV1();
void DIVU1();



void MADD1( );
void MADDU1( );

void MMI1( );
void MMI3( );

void PMFHL( );
void PMTHL( );
void PSLLH( );
void PSLLW( );

void PSRLH( );
void PSRAH( );
void PSRLW( );
void PSRAW( );



void MFC1( );
	
void CFC1( );			
void MTC1( );	

void CTC1( );	
void BC1( );	 		
void COP1_S( );
void COP1_D( );	
void COP1_W( );





	


void BC1F( ); 
void BC1T( );
void BC1FL( );
void BC1TL( );

void ADD_S( ); 		
void SUB_S( ); 		
void MUL_S( ); 		
void DIV_S( ); 		
void SQRT_S( ); 	
void ABS_S( ); 		
void MOV_S( ); 		
void NEG_S( );

void ADDA_S( );
void SUBA_S( );
void MULA_S( );

void MADD_S( );
void MSUB_S( );
void MADDA_S( );
void MSUBA_S( );





void RSQRT_S( );  	

void MAX_S( ); 
void MIN_S( ); 


		
void CVT_W_S( );	
	
void C_F_S( ); 		
	
void C_EQ_S( );		
	
void C_OLT_S( );	
	
void C_OLE_S( );	








void CVTS_W( );		
		


void MOVF_fmt( ); 
void MOVT_fmt( );	






void cop2_QMFC2( ); 
void cop2_CFC2( ); 
void cop2_QMTC2( ); 
void cop2_CTC2	( ); 	
void cop2_BC( ); 		
void cop2_Vopc( ); 


void VADDbc( ); 
void VSUBbc( ); 
void VMADDbc( ); 
void VMSUBbc( ); 
void VMAXbc( ); 
void VMINIbc( ); 
void VMULbc( ); 
void VMULq( ); 
void VMAXi( ); 
void VMULi( ); 
void VMINIi( ); 
void VADDq( ); 
void VMADDq( ); 
void VADDi( ); 
void VMADDi( ); 
void VSUBq( ); 
void VMSUBq( ); 
void VSUBi( ); 
void VMSUBi( ); 
void VADD( ); 
void VMADD( ); 
void VMUL( ); 
void VMAX( ); 
void VSUB( ); 
void VMSUB( ); 
void VOPMSUB( ); 
void VMINI( ); 
void VIADD( ); 
void VISUB( ); 
void VIADDI( ); 
void VIAND( ); 
void VIOR( ); 
void VCALLMS( ); 
void VCALLMSR( ); 
void Vopc_t60( ); 
void Vopc_t61( ); 
void Vopc_t62( ); 
void Vopc_t63( ); 


void VADDAbc( ); 
void VSUBAbc( ); 
void VMADDAbc( ); 
void VMSUBAbc( ); 
void VMULAbc( ); 

void VITOF12( ); 
void VFTOI12( ); 
void VMULAi( ); 
void VADDAi( ); 
void VSUBAi( ); 
void VMULA( ); 
void VOPMULA( ); 
void VLQD( ); 
void VRSQRT( ); 
void VILWR( ); 
void VRINIT( ); 		


void VITOF0( ); 
void VFTOI0( ); 
void VMULAq( ); 
void VADDAq( ); 
void VSUBAq( ); 
void VADDA( ); 
void VSUBA( ); 
void VMOVE( ); 
void VLQI( ); 
void VDIV( ); 
void VMTIR( ); 
void VRNEXT( ); 

void VITOF4( ); 
void VFTOI4( ); 
void VABS( ); 
void VMADDAq( ); 
void VMSUBAq( ); 
void VMADDA( ); 
void VMSUBA( ); 
void VMR32( ); 
void VSQI( ); 
void VSQRT( ); 
void VMFIR( ); 
void VRGET	( ); 	


void VITOF15( ); 
void VFTOI15( ); 
void VCLIP( ); 
void VMADDAi( ); 
void VMSUBAi( ); 
void VNOP( ); 
void VSQD( ); 
void VWAITQ( ); 
void VISWR( ); 
void VRXOR	( ); 	







#endif

