/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#ifndef _R5900_MAIN_TABLE_H
#define _R5900_MAIN_TABLE_H


static char * debug_r5900_reg [34] = {
"r0", "at", "v0", "v1", "a0", "a1", "a2", "a3",
"t0", "t1", "t2", "t3", "t4", "t5", "t6", "t7",
"s0", "s1", "s2", "s3", "s4", "s5", "s6", "s7",
"t8", "t9",
"k0", "k1",
"gp", "sp",
"s8",
"ra",
"hi", "lo"
};	

static char * debug_r5900_cop1_reg [32] = {
"fp0",	"fp1",	"fp2",	"fp3",	"fp4",	"fp5",	"fp6",	"fp7",
"fp8",	"fp9",	"fp10",	"fp11",	"fp12",	"fp13",	"fp14",	"fp15", 
"fp16",	"fp17",	"fp18",	"fp19",	"fp20",	"fp21",	"fp22",	"fp23",
"fp24", "fp25",	"fp26",	"fp27",	"fp28",	"fp29",	"fp30",	"fp31"
};	

static char * debug_r5900_cop0_reg [32] = {
	"Index",			"Random",	"EntryLo0",	"EntryLo1",	"Context",		"PageMask",		"Wired",	" ", 	
	"BadWAddr",			"Count",	"EntryHi",	"Compare",	"Status",		"Cause",		"EPC",		"PRiD",
	"Config/Config1",	" ",		"WatchLo",	"WatchHi",	"XContext",		" ", 			" ", 		"Debug",				
	"DEPC",				"PerfCnt",	"ErrCtl",	"CacheErr", "TagLo/DataLo",	"TagHi/DataHi",	"ErrorEPC",	"DESAVE"
};

static char * debug_vu_ccr_reg [ 32 ]= {
	"vi00",	"vi01",	"vi02", "vi03", "vi04",	"vi05",	"vi06", "vi07",
	"vi08",	"vi09",	"vi10",	"vi11",	"vi12",	"vi13",	"vi14",	"vi15",

	"status_flag",	"mac flag",		"clipping flag",	"reserved",	
	"R reg.",		"I reg.", 		"Q reg.",			"reserved",
	"reserved",		"reserved",		"tpc reg.", 		"cmasar0 reg.",
	"fbrst reg.", 	"vpu-stat reg.", "reserved", 		"cmasr1 reg."


};


static void (*normal_opc[64])(void) =
{
   SPECIAL,	REGIMM,		J,		JAL,	BEQ,		BNE,	BLEZ,	BGTZ,
   ADDI, 	ADDIU, 		SLTI,	SLTIU,	ANDI,		ORI,	XORI,	LUI,
   COP0, 	COP1, 		COP2,	NI,		BEQL,		BNEL,	BLEZL,	BGTZL,
   DADDI, 	DADDIU, 	LDL,	LDR,	SPECIAL2,	NI,		LQ,		SQ,
   LB, 		LH, 		LWL,	LW,		LBU,		LHU,	LWR,	LWU,
   SB, 		SH, 		SWL,	SW,		SDL,		SDR,	SWR,	CACHE,
   NI, 		LWC1, 		NI,		PREF,	NI,			NI,		LQC2,	LD,
   NI, 		SWC1, 		NI,		NI,		NI, 		NI,		SQC2,	SD
};



static char * debug_normal_opc[64] =
{
   "SPECIAL",	"REGIMM",	"J",	"JAL",		"BEQ",		"BNE",	"BLEZ",		"BGTZ",
   "ADDI",		"ADDIU",	"SLTI",	"SLTIU",	"ANDI",		"ORI",	"XORI", 	"LUI",
   "COP0",		"COP1",		"COP2",	"NI",		"BEQL",		"BNEL",	"BLEZL", 	"BGTZL",
   "DADDI",		"DADDIU",	"LDL",	"LDR",		"SPECIAL2",	"NI",	"LQ", 		"SQ",
   "LB",		"LH",		"LWL",	"LW",		"LBU",		"LHU",	"LWR",		"LWU",
   "SB",		"SH",		"SWL",	"SW",		"SDL",		"SDR",	"SWR",		"CACHE",
   "NI",		"LWC1",		"NI",	"PREF",		"NI",		"NI",	"LQC2",		"LD",
   "NI",		"SWC1",		"NI",	"NI",		"NI",		"NI",	"SQC2",		"SD"
};



static void (*special_opc[64])(void) =
{
   SLL,		NI,		SRL,	SRA,	SLLV,		NI,		SRLV,	SRAV,
   JR,		JALR,	MOVZ,	MOVN,	SYSCALL,	BREAK,	NI,		SYNC,
   MFHI,	MTHI,	MFLO,	MTLO,	DSLLV,		NI,		DSRLV,	DSRAV,
   MULT,	MULTU,	DIV,	DIVU,	NI,			NI,		NI,		NI,
   ADD,		ADDU,	SUB,	SUBU,	AND,		OR,		XOR,	NOR,
   MFSA,	MTSA,	SLT,	SLTU,	DADD,		DADDU,	DSUB,	DSUBU,
   TGE,		TGEU,	TLT,	TLTU,	TEQ,		NI,		TNE,	NI,
   DSLL,	NI,		DSRL,	DSRA,	DSLL32,		NI,		DSRL32,	DSRA32
};


static char * debug_special_opc[64] =
{
   "SLL",	"NI",		"SRL",	"SRA",	"SLLV",		"NI",		"SRLV",		"SRAV",
   "JR",	"JALR ",	"MOVZ",	"MOVN",	"SYSCALL",	"BREAK",	"NI",		"SYNC",
   "MFHI",	"MTHI",		"MFLO",	"MTLO",	"DSLLV",	"NI",		"DSRLV",	"DSRAV",
   "MULT",	"MULTU", 	"DIV",	"DIVU",	"NI",		"NI",		"NI",		"NI",
   "ADD",	"ADDU", 	"SUB",	"SUBU",	"AND",		"OR",		"XOR",		"NOR",
   "MFSA",	"MTSA",		"SLT",	"SLTU",	"DADD",		"DADDU",	"DSUB",		"DSUBU",
   "TGE",	"TGEU", 	"TLT",	"TLTU",	"TEQ",		"NI",		"TNE",		"NI",
   "DSLL",	"NI", 		"DSRL",	"DSRA",	"DSLL32",	"NI",		"DSRL32",	"DSRA32"
};



static void (*regimm_opc[32])(void) =
{
   BLTZ,	BGEZ,	BLTZL,		BGEZL,		NI,		NI,	NI,		NI,
   TGEI,	TGEIU, 	TLTI,		TLTIU,		TEQI,	NI,	TNEI,	NI,
   BLTZAL,	BGEZAL, BLTZALL,	BGEZALL,	NI,		NI,	NI,		NI,
   MTSAB,	MTSAH,	NI,			NI,			NI,		NI, NI,		NI 
};



static char * debug_regimm_opc[32] =
{
   "BLTZ",		"BGEZ",		"BLTZL",	"BGEZL",	"NI",	"NI",	"NI",	"NI",
   "TGEI",		"TGEIU", 	"TLTI",		"TLTIU",	"TEQI", "NI",	"TNEI",	"NI",
   "BLTZAL",	"BGEZAL",	"BLTZALL",	"BGEZALL",	"NI",	"NI",	"NI",	"NI",
   "MTSAB",		"MTSAH",	"NI",		"NI",		"NI",	"NI",	"NI",	"NI" 
};

static void (*cop0_opc[32])(void) =
{
	MF0,	NI,		NI,	NI,	MT0,	NI,	NI,	NI,
   	BC0, 	NI, 	NI,	NI,	NI,		NI,		NI, NI,
  	C0,		C0,		C0,	C0,	C0,		C0,		C0,	C0,
	C0,		C0,		C0,	C0,	C0,		C0,		C0,	C0
};



static char * debug_cop0_opc[32] =
{
   	"MF0", "NI",		"NI",	"NI",	"MT0",	"NI", 	"NI",	"NI",
   	"BC0", 	"NI", 		"NI", 	"NI", 	"NI", 	"NI", 		"NI", 	"NI",
  	"C0",	"C0",		"C0",	"C0",	"C0",	"C0",		"C0",	"C0",
   	"C0",	"C0",		"C0",	"C0",	"C0",	"C0",		"C0",	"C0"
};

static void (*cop0c0_opc[64])(void) =
{
	NI, 	TLBR, 	TLBWI, 	NI, 	NI,		NI,		TLBWR,		NI,
	TLBP,	NI,		NI,		NI,		NI,		NI,		NI,			NI,		
	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,
	ERET, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,	 
 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,
 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,
 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,
	EI, 	DI, 	NI, 	NI,		NI, 	NI, 	NI, 		NI  	 
};



static char * debug_cop0c0_opc[64] =
{
	"NI", 	"TLBR", "TLBWI", 	"NI", 	"NI",	"NI",	"TLBWR",	"NI",
	"TLBP",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",		
	"NI",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"ERET",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"NI",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"NI",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"NI",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"EI",	"DI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI" 	 
};

//SYSCALL TABLE FROM ROMAN
//[module]	KERNEL
//[made by]	[RO]man & others (october 2002)
static void (*syscall_fct[256])(void) = 
{ 
// 0x00
	SYSCALL_RFU000_FullReset,		SYSCALL_ResetEE,				SYSCALL_SetGsCrt,				SYSCALL_RFU003, 
	SYSCALL_Exit, 					SYSCALL_RFU005, 				SYSCALL_LoadPS2Exe, 			SYSCALL_ExecPS2, 
	SYSCALL_RFU008, 				SYSCALL_RFU009, 				SYSCALL_AddSbusIntcHandler,		SYSCALL_RemoveSbusIntcHandler, 
	SYSCALL_Interrupt2Iop, 			SYSCALL_SetVTLBRefillHandler,	SYSCALL_SetVCommonHandler, 		SYSCALL_SetVInterruptHandler,
// 0x10
	SYSCALL_AddIntcHandler,				SYSCALL_RemoveIntcHandler, 		SYSCALL_AddDmacHandler, 		SYSCALL_RemoveDmacHandler, 
	SYSCALL__EnableIntc, 				SYSCALL__DisableIntc, 			SYSCALL__EnableDmac, 			SYSCALL__DisableDmac, 
	SYSCALL__SetAlarm, 					SYSCALL__ReleaseAlarm, 			SYSCALL__EnableIntc, 			SYSCALL__DisableIntc, 
	SYSCALL__iEnableDmac, 				SYSCALL__iDisableDmac, 			SYSCALL__iSetAlarm, 			SYSCALL__iReleaseAlarm, 
// 0x20
	SYSCALL_CreateThread, 				SYSCALL_DeleteThread, 			SYSCALL_StartThread, 			SYSCALL_ExitThread,
	SYSCALL_ExitDeleteThread, 			SYSCALL_TerminateThread, 		SYSCALL_iTerminateThread, 		SYSCALL_DisableDispatchThread,
	SYSCALL_EnableDispatchThread, 		SYSCALL_ChangeThreadPriority, 	SYSCALL_iChangeThreadPriority, 	SYSCALL_RotateThreadReadyQueue,
	SYSCALL_iRotateThreadReadyQueue, 	SYSCALL_ReleaseWaitThread, 		SYSCALL_iReleaseWaitThread, 	SYSCALL_GetThreadId, 
// 0x30
	SYSCALL_ReferThreadStatus, 			SYSCALL_iReferThreadStatus, 	SYSCALL_SleepThread, 			SYSCALL_WakeupThread,
	SYSCALL_iWakeupThread, 				SYSCALL_CancelWakeupThread, 	SYSCALL_iCancelWakeupThread, 	SYSCALL_SuspendThread,
	SYSCALL_iSuspendThread, 			SYSCALL_ResumeThread, 			SYSCALL_iResumeThread, 			SYSCALL_JoinThread,
	SYSCALL_RFU060, 					SYSCALL_RFU061, 				SYSCALL_EndOfHeap, 				SYSCALL_RFU063, 
// 0x40
	SYSCALL_CreateSema, 				SYSCALL_DeleteSema, 			SYSCALL_SignalSema, 			SYSCALL_iSignalSema,
	SYSCALL_WaitSema, 					SYSCALL_PollSema, 				SYSCALL_iPollSema, 				SYSCALL_ReferSemaStatus,
	SYSCALL_iReferSemaStatus, 			SYSCALL_RFU073, 				SYSCALL_SetOsdConfigParam, 		SYSCALL_GetOsdConfigParam, 
	SYSCALL_GetGsHParam, 				SYSCALL_GetGsVParam, 			SYSCALL_SetGsHParam, 			SYSCALL_SetGsVParam, 
// 0x50
	SYSCALL_RFU080_CreateEventFlag, 	SYSCALL_RFU081_DeleteEventFlag, 		SYSCALL_RFU082_SetEventFlag, 	SYSCALL_RFU083_iSetEventFlag,
	SYSCALL_RFU084_ClearEventFlag, 		SYSCALL_RFU085_iClearEventFlag, 		SYSCALL_RFU086_WaitEvnetFlag, 	SYSCALL_RFU087_PollEvnetFlag, 
	SYSCALL_RFU088_iPollEvnetFlag, 		SYSCALL_RFU089_ReferEventFlagStatus, 	SYSCALL_NI, 					SYSCALL_RFU091, 
	SYSCALL_EnableIntcHandler, 			SYSCALL_DisableIntcHandler, 			SYSCALL_EnableDmacHandler, 		SYSCALL_DisableDmacHandler, 
// 0x60
	SYSCALL_KSeg0, 						SYSCALL_EnableCache, 					SYSCALL_DisableCache, 			SYSCALL_GetCop0,
	SYSCALL_FlushCache, 				SYSCALL_RFU101_105, 					SYSCALL_CpuConfig, 				SYSCALL_iGetCop0, 
	SYSCALL_iFlushCache, 				SYSCALL_RFU101_105, 					SYSCALL_iCpuConfig, 			SYSCALL_sceSifStopDma, 
	SYSCALL_SetCPUTimerHandler, 		SYSCALL_SetCPUTimer, 					SYSCALL_SetOsdConfigParam2, 	SYSCALL_SetOsdConfigParam2,	 
// 0x70
	SYSCALL_GsGetIMR, 					SYSCALL_GsPutIMR, 						SYSCALL_SetPgifHandler, 		SYSCALL_SetVSyncFlag,
	SYSCALL_RFU116, 					SYSCALL_print, 							SYSCALL_sceSifDmaStat, 			SYSCALL_sceSifSetDma,
	SYSCALL_sceSifSetDChain, 			SYSCALL_sceSifSetReg, 					SYSCALL_sceSifGetReg, 			SYSCALL_ExecOSD,
	SYSCALL_Deci2Call, 					SYSCALL_PSMode, 						SYSCALL_MachineType, 			SYSCALL_GetMemorySize,

	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI ,
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 	
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
	
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
	SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI 	

	
};

static char * debug_syscall[256] =
{ 
// 0x00
	"SYSCALL_RFU000_FullReset",			"SYSCALL_ResetEE",					"SYSCALL_SetGsCrt",				"SYSCALL_RFU003", 
	"SYSCALL_Exit", 					"SYSCALL_RFU005", 					"SYSCALL_LoadPS2Exe", 			"SYSCALL_ExecPS2", 
	"SYSCALL_RFU008", 					"SYSCALL_RFU009", 					"SYSCALL_AddSbusIntcHandler",	"SYSCALL_RemoveSbusIntcHandler", 
	"SYSCALL_Interrupt2Iop", 			"SYSCALL_SetVTLBRefillHandler",		"SYSCALL_SetVCommonHandler", 	"SYSCALL_SetVInterruptHandler",
// 0x10
	"SYSCALL_AddIntcHandler",			"SYSCALL_RemoveIntcHandler", 		"SYSCALL_AddDmacHandler", 		"SYSCALL_RemoveDmacHandler", 
	"SYSCALL__EnableIntc", 				"SYSCALL__DisableIntc", 			"SYSCALL__EnableDmac", 			"SYSCALL__DisableDmac", 
	"SYSCALL__SetAlarm", 				"SYSCALL__ReleaseAlarm", 			"SYSCALL__EnableIntc", 			"SYSCALL__DisableIntc", 
	"SYSCALL__iEnableDmac", 			"SYSCALL__iDisableDmac", 			"SYSCALL__iSetAlarm", 			"SYSCALL__iReleaseAlarm", 
// 0x20
	"SYSCALL_CreateThread", 			"SYSCALL_DeleteThread", 			"SYSCALL_StartThread", 				"SYSCALL_ExitThread",
	"SYSCALL_ExitDeleteThread", 		"SYSCALL_TerminateThread", 			"SYSCALL_iTerminateThread", 		"SYSCALL_DisableDispatchThread",
	"SYSCALL_EnableDispatchThread", 	"SYSCALL_ChangeThreadPriority", 	"SYSCALL_iChangeThreadPriority", 	"SYSCALL_RotateThreadReadyQueue",
	"SYSCALL_iRotateThreadReadyQueue", 	"SYSCALL_ReleaseWaitThread", 		"SYSCALL_iReleaseWaitThread", 		"SYSCALL_GetThreadId", 
// 0x30
	"SYSCALL_ReferThreadStatus", 		"SYSCALL_iReferThreadStatus", 		"SYSCALL_SleepThread", 			"SYSCALL_WakeupThread",
	"SYSCALL_iWakeupThread", 			"SYSCALL_CancelWakeupThread", 		"SYSCALL_iCancelWakeupThread", 	"SYSCALL_SuspendThread",
	"SYSCALL_iSuspendThread", 			"SYSCALL_ResumeThread", 			"SYSCALL_iResumeThread", 		"SYSCALL_JoinThread",
	"SYSCALL_RFU060", 					"SYSCALL_RFU061", 					"SYSCALL_EndOfHeap", 			"SYSCALL_RFU063", 
// 0x40
	"SYSCALL_CreateSema", 				"SYSCALL_DeleteSema", 				"SYSCALL_SignalSema", 			"SYSCALL_iSignalSema",
	"SYSCALL_WaitSema", 				"SYSCALL_PollSema", 				"SYSCALL_iPollSema", 			"SYSCALL_ReferSemaStatus",
	"SYSCALL_iReferSemaStatus", 		"SYSCALL_RFU073", 					"SYSCALL_SetOsdConfigParam", 	"SYSCALL_GetOsdConfigParam", 
	"SYSCALL_GetGsHParam", 				"SYSCALL_GetGsVParam", 				"SYSCALL_SetGsHParam", 			"SYSCALL_SetGsVParam" ,
// 0x50
	"SYSCALL_RFU080_CreateEventFlag", 	"SYSCALL_RFU081_DeleteEventFlag", 		"SYSCALL_RFU082_SetEventFlag", 	"SYSCALL_RFU083_iSetEventFlag",
	"SYSCALL_RFU084_ClearEventFlag", 	"SYSCALL_RFU085_iClearEventFlag", 		"SYSCALL_RFU086_WaitEvnetFlag", "SYSCALL_RFU087_PollEvnetFlag", 
	"SYSCALL_RFU088_iPollEvnetFlag", 	"SYSCALL_RFU089_ReferEventFlagStatus", 	"SYSCALL_NI", 					"SYSCALL_RFU091", 
	"SYSCALL_EnableIntcHandler", 		"SYSCALL_DisableIntcHandler", 			"SYSCALL_EnableDmacHandler", 	"SYSCALL_DisableDmacHandler", 
// 0x60
	"SYSCALL_KSeg0", 					"SYSCALL_EnableCache", 					"SYSCALL_DisableCache", 		"SYSCALL_GetCop0",
	"SYSCALL_FlushCache", 				"SYSCALL_RFU101_105", 					"SYSCALL_CpuConfig", 			"SYSCALL_iGetCop0", 
	"SYSCALL_iFlushCache", 				"SYSCALL_RFU101_105", 					"SYSCALL_iCpuConfig", 			"SYSCALL_sceSifStopDma", 
	"SYSCALL_SetCPUTimerHandler", 		"SYSCALL_SetCPUTimer", 					"SYSCALL_SetOsdConfigParam2", 	"SYSCALL_SetOsdConfigParam2",	 
// 0x70
	"SYSCALL_GsGetIMR", 				"SYSCALL_GsPutIMR", 					"SYSCALL_SetPgifHandler", 		"SYSCALL_SetVSyncFlag",
	"SYSCALL_RFU116", 					"SYSCALL_print", 						"SYSCALL_sceSifDmaStat", 		"SYSCALL_sceSifSetDma",
	"SYSCALL_sceSifSetDChain", 			"SYSCALL_sceSifSetReg", 				"SYSCALL_sceSifGetReg", 		"SYSCALL_ExecOSD",
	"SYSCALL_Deci2Call", 				"SYSCALL_PSMode", 						"SYSCALL_MachineType", 			"SYSCALL_GetMemorySize",

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,

	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI",
	"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 				"SYSCALL_NI" ,
	

	
};






static void (*special2_opc[64])(void) =
{
	MADD,	MADDU,	NI,		NI,		PLZCW,	NI,		NI,		NI,	
	MMI0,	MMI2,	NI,		NI,		NI,		NI,		NI,		NI,	
	MFHI1,	MTHI1,	MFLO1,	MTLO1,	NI,		NI,		NI,		NI,	
	MULT1,	MULTU1,	DIV1,	DIVU1,	NI,		NI,		NI,		NI,	
	MADD1,	MADDU1,	NI,		NI,		NI,		NI,		NI,		NI,	
	MMI1,	MMI3,	NI,		NI,		NI,		NI,		NI,		NI,	
	PMFHL,	PMTHL,	NI,		NI,		PSLLH,	NI,		PSRLH,	PSRAH,	
	NI,		NI,		NI,		NI,		PSLLW,	NI,		PSRLW,	PSRAW							
};



static char * debug_special2_opc[64] =
{
	"MADD",	"MADDU",	"NI",	"NI",	"PLZCW","NI",	"NI",	"NI",	
	"MMI0",	"MMI2",		"NI",	"NI",	"NI",	"NI",	"NI",	"NI",	
	"MFHI1","MTHI1",	"MFLO1","MTLO1","NI",	"NI",	"NI",	"NI",	
	"MULT1","MULTU1",	"DIV1",	"DIVU1","NI",	"NI",	"NI",	"NI",	
	"MADD1","MADDU1",	"NI",	"NI",	"NI",	"NI",	"NI",	"NI",	
	"MMI1",	"MMI3",		"NI",	"NI",	"NI",	"NI",	"NI",	"NI",	
	"PMFHL","PMTHL",	"NI",	"NI",	"PSLLH","NI",	"PSRLH","PSRAH",	
	"NI",	"NI",		"NI",	"NI",	"PSLLW","NI",	"PSRLW","PSRAW"							
};

static void (*cop1_opc[32])(void) =
{
	MFC1,	NI,		CFC1,	NI,		MTC1,	NI,		CTC1,	NI,
	BC1, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI,
	COP1_S,	NI, 	NI, 	NI, 	COP1_W,	NI,		NI, 	NI,
	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI							
};

;

static char * debug_cop1_opc[32] =
{
	"MFC1",		"NI",	"CFC1",	"NI",	"MTC1",		"NI",	"CTC1",	"NI",
	"BC1",		"NI", 	"NI", 	"NI", 	"NI", 		"NI",	"NI", 	"NI",
	"COP1_S",	"NI", 	"NI", 	"NI", 	"COP1_W",	"NI",	"NI", 	"NI",
	"NI", 		"NI", 	"NI", 	"NI", 	"NI", 		"NI",	"NI", 	"NI"							
};


static void (*cop1_bc1_opc[4])(void) =
{
	BC1F, BC1T,
	BC1FL,BC1TL
};


static char * debug_cop1_bc1_opc[4] =
{
	"BC1F", "BC1T",
	"BC1FL","BC1TL"
};

static void (*cop1_s_opc[64])(void) =
{
	ADD_S, 		SUB_S, 		MUL_S, 		DIV_S, 		SQRT_S, 	ABS_S, 		MOV_S, 		NEG_S,
	NI,			NI,			NI,			NI,			NI,			NI,			NI,			NI,
	NI,			NI,			NI,			NI,			NI,			NI,		 	RSQRT_S,  	NI,
	ADDA_S, 	SUBA_S,		MULA_S,		NI, 		MADD_S,		MSUB_S,		MADDA_S,	MSUBA_S,		
	NI,			NI, 		NI, 		NI,			CVT_W_S,	NI,			NI,			NI,
	MAX_S, 		MIN_S, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	C_F_S, 		NI,			C_EQ_S,		NI	,		C_OLT_S,	NI,			C_OLE_S,	NI,
	NI,			NI, 		NI,			NI,			NI,			NI,			NI,			NI
};



static char * debug_cop1_s_opc[64] =
{
	"ADD_S", 	"SUB_S", 	"MUL_S", 	"DIV_S", 	"SQRT_S", 	"ABS_S", 	"MOV_S", 	"NEG_S",
	"NI",		"NI",		"NI",		"NI",		"NI",		"NI",		"NI",		"NI",
	"NI",		"NI",		"NI",		"NI",		"NI",		"NI",  		"RSQRT_S", 	"NI",
	"ADDA_S", 	"SUBA_S", 	"MULA_S", 	"NI", 		"MADD_S", 	"MSUB_S", 	"MADDA_S", 	"MSUBA_S",		
	"NI",		"NI", 		"NI", 		"NI",		"CVT_W_S",	"NI",		"NI",		"NI",
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",		
	"C_F_S", 	"NI",		"C_EQ_S",	"NI",		"C_OLT_S",	"NI",		"C_OLE_S",	"NI",
	"NI",		"NI", 		"NI",		"NI",		"NI",		"NI",		"NI",		"NI"
};


static void (*cop1_W_L_opc[64])(void) =
{
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	CVTS_W,		NI,			NI, 	NI, 		NI, 		NI, 		NI, 	NI, 			
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI		
};



static char * debug_cop1_W_L_opc[64] =
{
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"CVT_S",	"NI",		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI"	
	
};

static void (*cop1_movcf_opc[2])(void) =	
{
	MOVF_fmt, MOVT_fmt	
};


static char * debug_cop1_movcf_opc[2] =
{
	"MOVF_fmt", "MOVT_fmt"	
};




static void (*cop2_opc[32])(void) = {
	NI, 		cop2_QMFC2, cop2_CFC2, 	NI, 		NI, 		cop2_QMTC2, cop2_CTC2, 	NI,		
	cop2_BC, 	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	cop2_Vopc, cop2_Vopc, 	cop2_Vopc, 	cop2_Vopc, cop2_Vopc, 	cop2_Vopc, 	cop2_Vopc, 	cop2_Vopc,		
	cop2_Vopc, cop2_Vopc, 	cop2_Vopc, 	cop2_Vopc, cop2_Vopc, 	cop2_Vopc, 	cop2_Vopc, 	cop2_Vopc		

};

static char * debug_pcop2_opc[32] = {
	"NI", 		"QMFC2", 	"CFC2", "NI", 	"NI", 	"QMTC2", 	"CTC2", 	"NI",		
	"BC", 		"NI", 		"NI", 	"NI", 	"NI", 	"NI", 		"NI", 		"NI",		
	"cop2_Vopc", "cop2_Vopc", 	"cop2_Vopc", 	"cop2_Vopc", "cop2_Vopc", "cop2_Vopc", 	"cop2_Vopc", 	"cop2_Vopc",		
	"cop2_Vopc", "cop2_Vopc", 	"cop2_Vopc", 	"cop2_Vopc", "cop2_Vopc", "cop2_Vopc", 	"cop2_Vopc", 	"cop2_Vopc"		

};


static void (*cop2_V_opc[64])(void) = {

	VADDbc,		VADDbc,		VADDbc,		VADDbc,		VSUBbc,		VSUBbc,		VSUBbc,		VSUBbc,
	VMADDbc,	VMADDbc,	VMADDbc,	VMADDbc,	VMSUBbc,	VMSUBbc,	VMSUBbc,	VMSUBbc,

	VMAXbc,		VMAXbc,		VMAXbc,		VMAXbc,		VMINIbc,	VMINIbc,	VMINIbc,	VMINIbc,
	VMULbc,		VMULbc,		VMULbc,		VMULbc,		VMULq,		VMAXi,		VMULi,		VMINIi,

	VADDq,		VMADDq,		VADDi,		VMADDi,		VSUBq,		VMSUBq,		VSUBi,		VMSUBi,
	VADD,		VMADD,		VMUL,		VMAX,		VSUB,		VMSUB,		VOPMSUB,	VMINI,

	VIADD,		VISUB,		VIADDI,		NI,			VIAND,		VIOR,		NI,			NI,
	VCALLMS,	VCALLMSR,	NI,			NI,			Vopc_t60,	Vopc_t61,	Vopc_t62,	Vopc_t63

};

static char * debug_pcop2_V_opc[64] = {
	"VADDbc",	"VADDbc",	"VADDbc",	"VADDbc",	"VSUBbc",	"VSUBbc",	"VSUBbc",	"VSUBbc",
	"VMADDbc",	"VMADDbc",	"VMADDbc",	"VMADDbc",	"VMSUBbc",	"VMSUBbc",	"VMSUBbc",	"VMSUBbc",

	"VMAXbc",	"VMAXbc",	"VMAXbc",	"VMAXbc",	"VMINIbc",	"VMINIbc",	"VMINIbc",	"VMINIbc",
	"VMULbc",	"VMULbc",	"VMULbc",	"VMULbc",	"VMULq",	"VMAXi",	"VMULi",	"VMINIi",

	"VADDq",	"VMADDq",	"VADDi",	"VMADDi",	"VSUBq",	"VMSUBq",	"VSUBi",	"VMSUBi",
	"VADD",		"VMADD",	"VMUL",		"VMAX",		"VSUB",		"VMSUB",	"VOPMSUB",	"VMINI",

	"VIADD",	"VISUB",	"VIADDI",	"NI",		"VIAND",	"VIOR",		"NI",		"NI",
	"VCALLMS",	"VCALLMSR",	"NI",		"NI",		"Vopc_t60",	"Vopc_t61",	"Vopc_t62",	"Vopc_t63"

};

static void (*cop2_V_t62_opc[32])(void) = {

	VADDAbc,	VSUBAbc,	VMADDAbc,	VMSUBAbc,	VITOF12,	VFTOI12,	VMULAbc,	VMULAi,
	VADDAi,		VSUBAi,		VMULA,		VOPMULA,	NI,			VLQD,		VRSQRT,		VILWR,
	VRINIT,		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI		



};

static char * debug_cop2_V_t62_opc[32] = {

	"VADDAbc",	"VSUBAbc",	"VMADDAbc",	"VMSUBAbc",	"VITOF12",	"VFTOI12",	"VMULAbc",	"VMULAi",
	"VADDAi",	"VSUBAi",	"VMULA",	"VOPMULA",	"NI",		"VLQD",		"VRSQRT",	"VILWR",
	"VRINIT",	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI",		
	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI"		



};

static void (*cop2_V_t60_opc[32])(void) = {

	VADDAbc,	VSUBAbc,	VMADDAbc,	VMSUBAbc,	VITOF0,		VFTOI0,		VMULAbc,	VMULAq,
	VADDAq,		VSUBAq,		VADDA,		VSUBA,		VMOVE,		VLQI,		VDIV,		VMTIR,
	VRNEXT,		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI		

};

static char * debug_cop2_V_t60_opc[32] = {
	
	"VADDAbc",	"VSUBAbc",	"VMADDAbc",	"VMSUBAbc",	"VITOF0",	"VFTOI0",	"VMULAbc",	"VMULAq",
	"VADDAq",	"VSUBAq",	"VADDA",	"VSUBA",	"VMOVE",	"VLQI",		"VDIV",		"VMTIR",
	"VRNEXT",	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI",		
	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI"		
	

};


static void (*cop2_V_t61_opc[32])(void) = {

	VADDAbc,	VSUBAbc,	VMADDAbc,	VMSUBAbc,	VITOF4,		VFTOI4,		VMULAbc,	VABS,
	VMADDAq,	VMSUBAq,	VMADDA,		VMSUBA,		VMR32,		VSQI,		VSQRT,		VMFIR,
	VRGET,		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI		

};

static char * debug_cop2_V_t61_opc[32] = {
	"VADDAbc",	"VSUBAbc",	"VMADDAbc",	"pMSUBAbc",	"VITOF4",	"VFTOI4",	"VMULAbc",	"VABS",
	"VMADDAq",	"VMSUBAq",	"VMADDA",	"VMSUBA",	"VMR32",	"VSQI",		"VSQRT",	"VMFIR",
	"VRGET",	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI",		
	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI"		
		

};


static void (*cop2_V_t63_opc[32])(void) = {

	VADDAbc,	VSUBAbc,	VMADDAbc,	VMSUBAbc,	VITOF15,	VFTOI15,	VMULAbc,	VCLIP,
	VMADDAi,	VMSUBAi,	NI,			VNOP,		NI,			VSQD,		VWAITQ,	VISWR,
	VRXOR,		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI		

};


static char * debug_cop2_V_t63_opc[32] = {
	"VADDAbc",	"VSUBAbc",	"VMADDAbc",	"VMSUBAbc",	"VITOF15",	"VFTOI15",	"VMULAbc",	"VCLIP",
	"VMADDAi",	"VMSUBAi",	"NI",		"VNOP",		"NI",		"VSQD",		"VWAITQ",		"VISWR",
	"VRXOR",	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI",		
	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI"		

};




#endif
