/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>


#include "nSX2.h"



#include "r5900_main.h"
#include "r5900_main_table.h"
 
#include "PS2Edefs.h"

#include "Sif.h"

/****************************************************************************************************/
//TEST 


SModuleBind nsx2SIFBindModule[SIF_PLUGGIN_MAX_BIND];


/*****************************************************************************************************************
									SYSCALL INSTRUCTION SET
*****************************************************************************************************************/

/*
Show Syscall Name in the window
*/
void SYSCALL_PrintDebugInfo() {
	char temp_string[256];
	_u8		SystemCallNumber;	
 	
  	SystemCallNumber = MipsCpu.GPR[CPU_REG_V1].lo & 0xFF;
	
 	if ((signed char)SystemCallNumber < 0) SystemCallNumber =(_u8)((- SystemCallNumber ) & 0xFF);
 	
	sprintf(temp_string,"%8.8llx:%s\n", (long)MipsCpu.PC , debug_syscall[SystemCallNumber]);
	PrintToEmuOutput (  temp_string );
}


/*
Syscall No Implemented
*/
void SYSCALL_NI() {

	printf("%8.8llx : Syscall_NI ( %x h) s8:%d u8:%d\n",(long)MipsCpu.PC ,(_u8) (MipsCpu.GPR[CPU_REG_V1].lo & 0xFF),(char) (MipsCpu.GPR[CPU_REG_V1].lo & 0xFF),(_u8) (MipsCpu.GPR[CPU_REG_V1].lo & 0xFF));
	
	MipsCpu.halt = 1;
}

/*

*/
void SYSCALL_RFU000_FullReset() { 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();
	MipsCpu.halt = 1; 
} 




/*
ResetEE	ENTRY_1	8000ad68

*/
void SYSCALL_ResetEE( )	{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();
	MipsCpu.halt = 1; 
}  

/*
SetGsCrt 02h
8000a060
*/
u64 GsCrtVal = 0x90b27d0000000000;

void _SetGsCrt2() {
	_u32 tmp;
	_u128 temp128	;
	
 	

	MipsMemoryRead( &temp128, DATA_W,0x8002f344, 0);
	
	if (temp128.lo == 0x40 || temp128.lo == 0x60 || temp128.lo == 0x61) {

		temp128.lo = 0;
		MipsMemoryWrite( temp128, DATA_B,0xbf803218, 0);	

		temp128.lo = 0;
		MipsMemoryWrite( temp128, DATA_B,0xbf803218, 2);	
		
 		return;
	}

  	temp128.lo = 0;
	MipsMemoryWrite( temp128, DATA_HW,0xbf801470, 0);	
	MipsMemoryWrite( temp128, DATA_HW,0xbf801472, 0);

	temp128.lo = 1;
 	MipsMemoryWrite( temp128, DATA_HW,0xbf801472, 0);

}

void SYSCALL_SetGsCrt( ) { 
	char temp_string[256];	
	_u32 arg0, arg1, arg2;
	_u64 val, val2;
	_u64 tmp;
	
	_u128	temp128;

	if ( debug_print_syscall == 1 )	{
		SYSCALL_PrintDebugInfo();
		sprintf(temp_string,"|A0: %8.8llx, A1: 0x%8.8llx, A2:%8.8llx\n",(long)MipsCpu.GPR[CPU_REG_A0].lo,MipsCpu.GPR[CPU_REG_A1].lo,MipsCpu.GPR[CPU_REG_A2].lo);
		PrintToBIOSOutput (  temp_string );
		
	}

    arg0 = MipsCpu.GPR[CPU_REG_A0].lo & 0xFFFF;
	arg1 = MipsCpu.GPR[CPU_REG_A1].lo & 0xFFFF;
	arg2 = MipsCpu.GPR[CPU_REG_A2].lo & 0xFFFF;
/*
	if (arg1 == 0) {
		SysPrintf("unhandled arg1 == 0 on SetGsCrt!!\n");
	}
*/
 

  	temp128.lo = 0;
	MipsMemoryWrite( temp128, DATA_W,0x8002f344, 0);	

/*
	if (arg1 != 2) {
		SysPrintf("unhandled case on SetGsCrt!!\n");
	}
*/

	if (arg0 != 0) {
		val = 0x740834504;
		val2 = 0x740814504;

		tmp = (s32)GsCrtVal & 0x1;
		tmp<<= 25;
		val|= tmp;
		val2|= tmp;

		(*GSwrite64)(0x12000010, val);
		(*GSwrite64)(0x12000040, 0x7F5B61F06F040);
		(*GSwrite64)(0x12000050, 0x33A4D8);
		(*GSwrite64)(0x12000060, 0xC7800601A01801);

		tmp = (_u64)arg2 << 48;
		tmp>>= 15;
		tmp|= 1;
		(*GSwrite64)(0x12000020, tmp);
		(*GSwrite64)(0x12000030, 8);
		(*GSwrite64)(0x12000010, val2);
	} else {
		val = 0x740834504;
		val2 = 0x740814504;

		tmp = (GsCrtVal >> 1) & 0x1;
		tmp<<= 36;
		val|= tmp;
		val2|= tmp;

		tmp = (_s32)GsCrtVal & 0x1;
		tmp<<= 25;
		val|= tmp;
		val2|= tmp;

		(*GSwrite64)(0x12000010, val);
		(*GSwrite64)(0x12000040, 0x7F5B61F06F040);
		(*GSwrite64)(0x12000050, 0x33A4D8);
		(*GSwrite64)(0x12000060, 0xC7800601A01802);
		(*GSwrite64)(0x12000020, 0);
		(*GSwrite64)(0x12000030, 8);
		(*GSwrite64)(0x12000010, val2);
	}
	_SetGsCrt2(); 

	MipsCpu.PC = 	MipsCpu.PC + 4;	
} 


/*


*/
void SYSCALL_RFU003( ) { 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 


/*

*/ 
void SYSCALL_Exit( ) 							{ 
	static	AlreadyPrint = 0;


	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();
	if ( !AlreadyPrint ) {
 		PrintToEmuOutput("Interpreter Stop ( Syscall Exit )");	
 		AlreadyPrint = 1;
   		}
 		
	MipsCpu.halt = 1; 
 	
} 


/*
RFU005	ENTRY_5	80002880
*/ 
void SYSCALL_RFU005( ) 							{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}


/*
LoadPS2Exe	ENTRY_6	800055a0

*/  
void SYSCALL_LoadPS2Exe( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 


/*
ExecPS2	ENTRY_7	80002f80


*/ 
void SYSCALL_ExecPS2( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}

/*
RFU008	ENTRY_8

*/  
void SYSCALL_RFU008( ) 							{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}  

/*
RFU009	ENTRY_9	80005b28
*/
void SYSCALL_RFU009( ) 							{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}  

/*
AddSbusIntcHandler	ENTRY_10	80001e78

*/
void SYSCALL_AddSbusIntcHandler( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}

/*
RemoveSbusIntcHandler	ENTRY_11	80001ed0


*/  
void SYSCALL_RemoveSbusIntcHandler( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}

/*
Interrupt2Iop	ENTRY_12	80001f70

*/  
void SYSCALL_Interrupt2Iop( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}


/*
SetVTLBRefillHandler	ENTRY_13	800009c0


*/  
void SYSCALL_SetVTLBRefillHandler( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}

/*
SetVCommonHandler	ENTRY_14	80000a00


*/  
void SYSCALL_SetVCommonHandler( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}  

/*
SetVInterruptHandler	ENTRY_15	80000a40


*/
void SYSCALL_SetVInterruptHandler( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}  

/**********************************************************************************************************
									DMA CHANNEL CONTROL
***********************************************************************************************************/


/*
_EnableDmac	

Description :
This system call enables DMA termination interrupts for the specified channel.

Params:
a0 : Channel Number

Return:
v0 : 	0 Already enabled
		1 Enabled
*/
void SYSCALL__EnableDmac( )  					{
	char temp_string[256];
	_u128 dmac_stat;
    _u32  newValue;

	if ( debug_print_syscall == 1 )	{
		SYSCALL_PrintDebugInfo();
		sprintf(temp_string,"|Channel: %ld\n",(long)MipsCpu.GPR[CPU_REG_A0].lo);PrintToBIOSOutput (  temp_string );
		
	}
	
	/* Read the Dmac channel Interrupt Status register */
	MipsMemoryReadW ( SpecialAreaMemory, &dmac_stat , (DMA_STAT & 0xFFFF) ) ;	//don't need DMA Check
	
	/* compute the new value */
    newValue = ( 0x10000 << MipsCpu.GPR[CPU_REG_A0].lo ) &  dmac_stat.lo;
    
    /*If the Interrupt is already Enabled */
    if ( newValue != 0 ) {
		/* return 0 */
		MipsCpu.GPR[CPU_REG_V0].lo =  0;
     }
    /* Else enable the Interrupt for the specified channel */
    else {
        /* Write the new value of DMA_STAT */
		dmac_stat.lo = newValue ;
        MipsMemoryWrite ( dmac_stat  , DATA_W ,  DMA_STAT  ,0 ) ;		//hum... maybe DMA check don't needed
        DmaUpdate();
		/* return 1 */
        MipsCpu.GPR[CPU_REG_V0].lo =  1;
    }
 		
	INCREMENT_PC();

} 


/*
_DisableDmac	ENTRY_23	80000980

Description :
This system call disables DMA termination interrupts for the specified channel.

Params:
a0 : Channel Number

Return:
v0 : 	0 Already disabled
		1 disabled

*/
void SYSCALL__DisableDmac( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}


void SYSCALL__iDisableDmac( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
} 


void SYSCALL__iEnableDmac( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     



/**********************************************************************************************************
				DMA CHANNEL HANDLER									
***********************************************************************************************************/


void SYSCALL_EnableDmacHandler( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_DisableDmacHandler( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



/*
AddDmacHandler	ENTRY_18	80001c78

Description :
Adds a DMA interrupt handler by DMA channel. handler is the address of the handler 
that will be called at the time of the DMA interrupt. channel is the DMA channel 
number and will be passed to the handler in argument ch. next is the address of 
a previously registered DMA interrupt handler. If next is 0, handler will
be registered as the first interrupt handler. If next is -1, handler will be 
registered as the last interrupt handler.

Note: When a DMA interrupt is generated, the GPRs are saved before the interrupt 
handler is called. When the handler has finished executing, the GPRs are 
restored. However, note that there is no save/restore of FPU registers.

When writing interrupt handlers, note that interrupts are disabled and that 
different APIs can be used. Refer to \overview\eekernel for information on 
these issues.

If an interrupt handler returns -1, subsequently registered interrupt handlers 
will not be called.


Params :
a0: channel number
a1: Address handler
a2: position of the handler ( not used yet )

Return:
normal termination : Handler ID
Error : -1
*/
void SYSCALL_AddDmacHandler( ) {

	char temp_string[256];
	_u8		DMA_channel;
	_u64	DMA_handler_addr;
	_u64	Dma_next_handler;

	DMA_channel 		= MipsCpu.GPR[CPU_REG_A0].lo & 0xFF;
	DMA_handler_addr	= MipsCpu.GPR[CPU_REG_A1].lo;
	Dma_next_handler	= MipsCpu.GPR[CPU_REG_A2].lo;
	
	if ( debug_print_syscall == 1 )	{
		SYSCALL_PrintDebugInfo();
		sprintf(temp_string,"|channel:%d, Addr:0x%8.8lx, next:%d\n",DMA_channel, (long)DMA_handler_addr,(long)Dma_next_handler);
		PrintToBIOSOutput (  temp_string );
	}
    
	/* if DMA handler mus tbe registered as first handler */
	if ( Dma_next_handler == 0 ) {
		
		/* id Dma handler is not already enabled */
		if ( Ps2Bios.DmaH[ DMA_channel ].Status == 0 ) {

	    	/* Create a new DMA Handler for the specified Channel */
    		Ps2Bios.DmaH[ DMA_channel ].Add 	= DMA_handler_addr ;
			Ps2Bios.DmaH[ DMA_channel ].ID 		= DMA_channel ;
			Ps2Bios.DmaH[ DMA_channel ].Status 	= 1 ;

			/* return DMA Channel ID (??)*/
			MipsCpu.GPR[CPU_REG_V0].lo = DMA_channel ;

		} else {
			/* Channel has already an Handler */
			PrintToBIOSOutput ( "|Channel has already an Handler!\n" );
			MipsCpu.halt = 1;
		}
	} else {
		/* chennel handler must be register has last handler */
		PrintToBIOSOutput ( "|Chennel handler must be register has last handler !\n" );
		MipsCpu.halt = 1;
	}
	
	
	INCREMENT_PC();
} 


/*
RemoveDmacHandler	ENTRY_19	80001cb8
*/
void SYSCALL_RemoveDmacHandler( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}   


void SYSCALL_iDisableDmacHandler( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL_iEnableDmacHandler( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     




/**********************************************************************************************************
							INTERRUPTS BY CAUSE		
***********************************************************************************************************/

char * debugIntrptCause[ 11 ] = {"GS", "SBUS", "V-blank start", "V-blank end", "VIF0", "VIF1", "VU0", "VU1", "IPU", "Timer0", "Timer1" };


/*
_EnableIntc	ENTRY_20	800008c0

Description:This system call enables interrupts triggered by cause.

Param: 
AO : Cause

Return value
0 Already enabled
1 Changed to enabled

*/
void SYSCALL__EnableIntc( ) { 
	char 	temp_string[256];	//Debug Text
	_u128 	intc_stat;			//Interupt by Cause Value
    _u8		cause;				//Cause ID
          
    _u32 newValue;				//New Value of Interrupt by Cause

	cause = MipsCpu.GPR[CPU_REG_A0].lo;

	/* Show Debug Info */
	if ( debug_print_syscall == 1 )	{
		SYSCALL_PrintDebugInfo();
		sprintf(temp_string,"|cause: %ld(%s)\n",cause,debugIntrptCause[cause]);
		PrintToBIOSOutput (  temp_string );
	}
	
	/* Read the Interrupt Mask register */
	MipsMemoryReadW ( SpecialAreaMemory, &intc_stat , (INTC_MASK & 0xFFFF) ) ;	//don't need DMA Check
	
	/* Enable the Interrupt*/
    newValue = ( 0x1 << MipsCpu.GPR[CPU_REG_A0].lo ) & intc_stat.lo ;
 
    
    //If the Interrupt is already Enable return 0
    if ( newValue != 0 ) {
         MipsCpu.GPR[CPU_REG_V0].lo =  0;
     }
    //Else enable the Interrupt and return 1
    else {
        intc_stat.lo = newValue;
		
        /* Write new Value to INTC_MASK register */ 
		MipsMemoryWrite ( intc_stat  , DATA_W ,  INTC_MASK  ,0 ) ;
        DmaUpdate();
       
		MipsCpu.GPR[CPU_REG_V0].lo =  1;
    }
		
	INCREMENT_PC();  
	
}   

/*
_DisableIntc	ENTRY_21	80000900
*/
void SYSCALL__DisableIntc( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}   


void SYSCALL__iDisableIntc( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL__iEnableIntc( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


/**********************************************************************************************************
				INTERRUPT BY CAUSE HANDLER								
***********************************************************************************************************/

/*
AddIntcHandler	ENTRY_16	80001a30


Description: Registers an INTC handler by interrupt cause.
cause is the interrupt cause. handler is the address of the handler that will be called when an interrupt
is generated, and will be passed the interrupt cause in the argument ca. next is the handler ID of a 
previously registered handler. If next is 0, the handler will be registered as the first handler.
If next is -1, the handler will be registered as the last handler.

Note: When a INTC interrupt is generated, the GPRs are saved before the interrupt handler is called. When
the handler has finished executing, the GPRs are restored. However, note that there is no save/restore of
FPU registers.
When writing interrupt handlers, note that interrupts are disabled and that different APIs can be used. 
Referto \overview\eekernel for information on these issues.

If an interrupt handler returns -1, subsequently registered interrupt handlers will not be called.

Param:
A0 : Cause ID
A1 : Handler Adress
A2 : Next ( ?, not sure of this )

Return:
Handler ID  :Normal termination
-1 			:Error return

*/
void SYSCALL_AddIntcHandler( ) 					{ 
	char temp_string[256];
	
	_u8		CauseID;
	_u32	IntcHandlerAddr;
	_u32	IntcNextRegisterHandler;

	CauseID  				= MipsCpu.GPR[CPU_REG_A0].lo & 0xFF;
	IntcHandlerAddr 		= MipsCpu.GPR[CPU_REG_A1].lo;
	IntcNextRegisterHandler = MipsCpu.GPR[CPU_REG_A2].lo;


	if ( debug_print_syscall == 1 )	{
 		SYSCALL_PrintDebugInfo();

		sprintf(temp_string,"|cause:%d(%s), Addr:0x%8.8lx, next:%d\n",CauseID,debugIntrptCause[CauseID] ,IntcHandlerAddr,IntcNextRegisterHandler);
		PrintToBIOSOutput (  temp_string );
	
	}

	if ( IntcNextRegisterHandler == 0 ) {
	
		if ( Ps2Bios.IntCH[ CauseID ].Status == 0 ) {

		    /* Create a new Interrupt  Handler for the specified Cause */
		    Ps2Bios.IntCH[ CauseID ].Add 		= IntcHandlerAddr ;
			Ps2Bios.IntCH[ CauseID ].ID 		= CauseID ;
			Ps2Bios.IntCH[ CauseID ].Status 	= 1 ;

			MipsCpu.GPR[CPU_REG_V0].lo 			=  CauseID;

		}
		else {
			/* Interrupt has already an Handler */
			PrintToBIOSOutput ( "|Interrupt has already an Handler!\n" );
			MipsCpu.halt = 1;
		}
	}else {
		/* Interrupt handler must be register has last handler */
		PrintToBIOSOutput ( "|Interrupt handler must be register has last handler !\n" );
		MipsCpu.halt = 1;
	}
 
	INCREMENT_PC(); 
}  

/*
RemoveIntcHandler	ENTRY_17	80001a70
*/
void SYSCALL_RemoveIntcHandler( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}  


void SYSCALL_EnableIntcHandler( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_DisableIntcHandler( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_iDisableIntcHandler( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL_iEnableIntcHandler( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     



/**********************************************************************************************************
									ALARM
***********************************************************************************************************/


/* _SetAlarm	ENTRY_24	800022d8 */ 
void SYSCALL__SetAlarm( ) { 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 

/* _ReleaseAlarm	ENTRY_25	80002570 */
void SYSCALL__ReleaseAlarm( ) { 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 

void SYSCALL__iReleaseAlarm( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL__iSetAlarm( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


/**********************************************************************************************************
									THREADS
***********************************************************************************************************/


/* Constants indicating state of thread */	
#define	THS_RUN 			0x01 	//RUN state
#define THS_READY 			0x02 	//READY state
#define THS_WAIT 			0x04 	//WAIT state
#define THS_SUSPEND			0x08 	//SUSPEND state
#define	THS_WAITSUSPEND 	0x0c 	//WAIT-SUSPEND state
#define	THS_DORMANT 		0x10 	//DORMANT state

/* Values used to indicate WAIT type */
#define THS_WAITTYPE_NO 			0 		//Not in WAIT state
#define THS_WAITTYPE_WAKUPREQUEST  	1 		//Waiting for WAKUP request
#define	THS_WAITTYPE_SEMAPHORE		2 		//Waiting for semaphore

typedef struct _ThreadParam {
	_s32 status; 				//Thread status
	_u32 entry_add;				//void (*entry)(void *); Entry address for execution 	(*)
	_u32 stack_add;				//void *stack; Stack address used by thread 			(*) (16-byte alignment)
	_s32 stackSize; 			//Stack size (in bytes: multiple of 16) 				(*)
	_u32 gpReg_add;				//void *gpReg; Value of GP (Global Pointer) register 	(*)
	_s32 initPriority;			//Initial priority (0 - 128) 							(*)
	_s32 currentPriority;		//Current priority (0 - 128)
	_u32 attr; 					//System Reserved (value is arbitrary)
	_u32 option; 				//Optional user-defined information
	_s32 waitType; 				//WAIT type
	_s32 waitId;				//semaphore ID if WAIT type is "semaphore"
	_s32 wakeupCount; 			//Wakeup request count
}ThreadParam; 

/*
CreateThread	ENTRY_32	80003c50
*/
void SYSCALL_CreateThread( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}

/*
DeleteThread	ENTRY_33	80002fc0


*/ 
void SYSCALL_DeleteThread( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}

/*
StartThread	ENTRY_34	80003040


*/ 
void SYSCALL_StartThread( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}


/*
ExitThread	ENTRY_35	800030c0


*/ 
void SYSCALL_ExitThread( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 

/*
ExitDeleteThread	ENTRY_36	80003100


*/
void SYSCALL_ExitDeleteThread( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}

/*
TerminateThread	ENTRY_37	80003140
*/
 
void SYSCALL_TerminateThread( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 

/*
DisableDispatchThread	ENTRY_39	80004228

*/
void SYSCALL_DisableDispatchThread( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 

/*
EnableDispatchThread	ENTRY_40	80004258

*/
void SYSCALL_EnableDispatchThread( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 



void SYSCALL_ChangeThreadPriority( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 




void SYSCALL_RotateThreadReadyQueue( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 




void SYSCALL_ReleaseWaitThread( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 




void SYSCALL_GetThreadId( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 



void SYSCALL_ReferThreadStatus( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 



void SYSCALL_SleepThread( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();
 
	//MipsCpu.halt = 1; 
	INCREMENT_PC();
} 



void SYSCALL_WakeupThread( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 



void SYSCALL_CancelWakeupThread( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 



void SYSCALL_SuspendThread( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 



void SYSCALL_ResumeThread( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 



void SYSCALL_JoinThread( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
} 



void SYSCALL_iResumeThread( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL_iSuspendThread( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL_iCancelWakeupThread( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL_iWakeupThread( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL_iReferThreadStatus( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL_iReleaseWaitThread( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL_iRotateThreadReadyQueue( )			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL_iChangeThreadPriority( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}    


void SYSCALL_iTerminateThread( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
} 
   


/**********************************************************************************************************
									SEMAPHORE
***********************************************************************************************************/

/*
Kernel Semaphore Structure
*/
typedef struct _SemaParam {
    _s32 currentCount;               //Current semaphore count
    _s32 maxCount;                   //Maximum semaphore count
    _s32 initCount;                  //Initial semaphore count
    _s32 numWaitThreads;             //Number of threads waiting on semaphore
    _s32 attr;                       //Semaphore attribute
    _u32 option;                   	//
} SemaParam;

/*
Create a Semaphore

Param:
A0: address of sema param

Return:
semaphore ID (Normal termination)

*/
void SYSCALL_CreateSema( void ) { 
	char temp_string[256];			//Debug Text	
    _u8 boucle;						//loop var
    
    SemaParam  	*mysm;				//pointer to Semaphore Structure
    _s8			FreeSemaRoom;		//ID of a free Semaphore Room  in the BIOS
   
    _u64    TerminationValue;		//Return Value
    
    
   	/* Read the Semaphore Structure */
   	mysm = (  SemaParam * )	&MipsMemory [  MipsCpu.GPR[CPU_REG_A0].lo & 0x01FFFFFF ];
   	
	/* Show Debug Info */
	if ( debug_print_syscall == 1 )	{
     	SYSCALL_PrintDebugInfo();
	
		sprintf(temp_string,"|Address : %llx \n",MipsCpu.GPR[CPU_REG_A0].lo );		PrintToBIOSOutput (  temp_string );
    	sprintf(temp_string,"|Sema current: %x\n",    	mysm->currentCount);		PrintToBIOSOutput (  temp_string );             
    	sprintf(temp_string,"|Sema MaxCoun: %x\n",    	mysm->maxCount);			PrintToBIOSOutput (  temp_string );
    	sprintf(temp_string,"|Sema Initial: %x\n",    	mysm->initCount);			PrintToBIOSOutput (  temp_string ); 
    	sprintf(temp_string,"|Nb thrds wtg: %x\n",    	mysm->numWaitThreads);		PrintToBIOSOutput (  temp_string );
    	sprintf(temp_string,"|Sema attribu: %x\n",    	mysm->attr);				PrintToBIOSOutput (  temp_string );          
    	sprintf(temp_string,"|Option: %x\n",    		mysm->option);				PrintToBIOSOutput (  temp_string );              
   }
   
	/* Find the first Free Semaphore Room */
	FreeSemaRoom = -1;

	for ( boucle = 0 ; boucle < BIOS_MAX_SEMAPHORE ; boucle++){

		if ( Ps2Bios.SemaState[ boucle ] == BIOS_SEMA_ROOMFREE ) {
   			FreeSemaRoom = boucle;
    		break;
		}
	}

	/* Check If a there is a free room left */
    if ( FreeSemaRoom < BIOS_MAX_SEMAPHORE ) {
    	
    	/* Mark this room as OCCUPIED */
		Ps2Bios.SemaState[ boucle ] = BIOS_SEMA_ROOMBUSY;

		/* Copy the Semaphore */
        Ps2Bios.Sema[ FreeSemaRoom ].MemAddress		= MipsCpu.GPR[CPU_REG_A0].lo;
        Ps2Bios.Sema[ FreeSemaRoom ].currentCount	= mysm->currentCount;
        Ps2Bios.Sema[ FreeSemaRoom ].maxCount		= mysm->maxCount;
        Ps2Bios.Sema[ FreeSemaRoom ].initCount		= mysm->initCount;
		Ps2Bios.Sema[ FreeSemaRoom ].numWaitThreads	= mysm->numWaitThreads;
		Ps2Bios.Sema[ FreeSemaRoom ].attr			= mysm->attr;
		Ps2Bios.Sema[ FreeSemaRoom ].option			= mysm->option;
    
    }
 	
 	/* Return Value */
    MipsCpu.GPR[CPU_REG_V0].lo = (_u64)FreeSemaRoom;

	INCREMENT_PC();	
} 

/*
Delete Sema

Description:Deletes the specified semaphore. 
An error is returned to threads that have been registered in the
semaphore's wait queue.

Param:
A0 : Semaphore ID

Return:
semaphore ID (Normal termination)
*/
void SYSCALL_DeleteSema( void ){ 
	char temp_string[256];		//Debug Text
	_u8	SemaID;					//Semaphore ID

	/* Show Debug Info */
	if ( debug_print_syscall == 1 )	{
        SYSCALL_PrintDebugInfo();	
    	sprintf(temp_string,"|SemaID : %d \n",MipsCpu.GPR[CPU_REG_A0].lo );PrintToBIOSOutput (  temp_string );
	}
	
	/* Mark the Sema ID as FREE ROOM */
 	SemaID = MipsCpu.GPR[CPU_REG_A0].lo ;
 	Ps2Bios.SemaState[ SemaID ] = BIOS_SEMA_ROOMFREE;

	/* Reset All Semaphore param */
    Ps2Bios.Sema[ SemaID ].MemAddress		= 0;
    Ps2Bios.Sema[ SemaID ].currentCount		= 0;
    Ps2Bios.Sema[ SemaID ].maxCount			= 0;
    Ps2Bios.Sema[ SemaID ].initCount		= 0;
	Ps2Bios.Sema[ SemaID ].numWaitThreads	= 0;
	Ps2Bios.Sema[ SemaID ].attr				= 0;
	Ps2Bios.Sema[ SemaID ].option			= 0;
 	
 	/* Return Semaphore ID */
    MipsCpu.GPR[CPU_REG_V0].lo = SemaID;
 
    INCREMENT_PC();	
}  


/*
Signal Semaphore
Description:Release semaphore resource

When the value of sid is 0 and there is no free space in the semaphore queue, 
the thread at the start of the semaphore's wait queue will be released and 
placed in READY state. 
In all other cases, the value of the semaphore is incremented.
For normal termination, the semaphore ID is returned. 
If an invalid sid is specified, a THREAD_ERROR is
returned.

Param:
A0 : Semaphore ID

Return:
semaphore ID (Normal termination)
*/
void SYSCALL_SignalSema( void ) { 
	char temp_string[256];			//Debug Text
	_u32	SemaID;					//Semaphore ID

	/* Show Debug Text */
	if ( debug_print_syscall == 1 )	{
        SYSCALL_PrintDebugInfo();	
    	sprintf(temp_string,"|SemaID : %d \n",MipsCpu.GPR[CPU_REG_A0].lo );PrintToBIOSOutput (  temp_string );
	}
 		
 	/* Get Semaphore ID */
	SemaID = MipsCpu.GPR[CPU_REG_A0].lo;

	/* there is no free space in the semaphore queue */
	if ( Ps2Bios.Sema[ SemaID ].numWaitThreads < 0 ){
	 	if ( debug_print_syscall == 1 )	PrintToBIOSOutput (  " ** SignalSema ** numWaitThreads <  0 **\n" );
	 } else {
	 	/* the value of the semaphore is incremented */
		Ps2Bios.Sema[ SemaID ].currentCount = Ps2Bios.Sema[ SemaID ].currentCount + 1;
	}
	
	/*Return Value */
    MipsCpu.GPR[CPU_REG_V0].lo = MipsCpu.GPR[CPU_REG_A0].lo;
 
    INCREMENT_PC();	
}   




/*
Wait Semaphore

Description:Get semaphore resource

If the value of the semaphore specified by sid is greater than 1, 
the semaphore is decremented and the function immediately terminates with a normal return. 
If the value of the semaphore is zero, the thread is put in WAIT state and 
placed in the semaphore's wait queue until another thread increments the semaphore by
issuing a SignalSema.

Param:
A0 : Semaphore ID

Return:
semaphore ID (Normal termination)
*/
void SYSCALL_WaitSema( void ) { 
	char temp_string[256];		//Debug Text
	_u32	SemaID;				//Semaphore ID

	static	temp_toto = 0;

	/* Get Semaphore ID */
	SemaID = MipsCpu.GPR[CPU_REG_A0].lo;

	/* Show Debug Text */
	if ( debug_print_syscall == 1 )	{
        SYSCALL_PrintDebugInfo();	
    	sprintf(temp_string,"|SemaID : %d \n",SemaID );PrintToBIOSOutput (  temp_string );
    
	}
	
	/* if value of the semaphore is greater than 1 */
	if ( Ps2Bios.Sema[ SemaID ].currentCount >= 1 ){
	 	/* the semaphore is decremented */
	 	Ps2Bios.Sema[ SemaID ].currentCount = Ps2Bios.Sema[ SemaID ].currentCount - 1;
	 
	} else {
	 	/* the thread is put in WAIT state */
	 	if ( debug_print_syscall == 1 )	PrintToBIOSOutput(  "** WaitSema ** SEMA COUNT REACH 0 **\n" );
		temp_toto++;
/*
		if ( temp_toto > 5 ) {
			debug_op = 1;
			MipsCpu.halt = 1;
		}
*/	 
	 }

 	/* return value */
    MipsCpu.GPR[CPU_REG_V0].lo = MipsCpu.GPR[CPU_REG_A0].lo;
 
 	
    INCREMENT_PC();	
}   


/*
The PollSema system call is the same as WaitSema except that the thread does not enter WAIT state.
Unlike WaitSema, an error will be returned if the value of the semaphore is 0.
*/
void SYSCALL_PollSema( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_ReferSemaStatus( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   


void SYSCALL_iReferSemaStatus( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL_iPollSema( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     



void SYSCALL_iSignalSema( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     




/**********************************************************************************************************
								GS									
***********************************************************************************************************/


/*

*/
void SYSCALL_GsGetIMR( ) 						{ 
	_u128	temp128;
	
 	if ( debug_print_syscall == 1 )	{ 	SYSCALL_PrintDebugInfo(); }	
	
	MipsMemoryRead ( &temp128 , DATA_DW ,  GS_IMR  ,0 ) ;
	MipsCpu.GPR[CPU_REG_V0].lo = temp128.lo;

	MipsCpu.PC = MipsCpu.PC + 4;
} 

/*
GsPutIMR
Write A0 to 0x12001010
V0 = A0
*/
void SYSCALL_GsPutIMR( ) 						{ 
	char temp_string[256];

	if ( debug_print_syscall == 1 )	{
		SYSCALL_PrintDebugInfo();		
		sprintf(temp_string,"|A0= 0x%8.8llx\n",MipsCpu.GPR[CPU_REG_A0].lo);
		PrintToBIOSOutput (  temp_string );
	}

	MipsCpu.GPR[CPU_REG_V0].lo = MipsCpu.GPR[CPU_REG_A0].lo;
	MipsMemoryWrite ( MipsCpu.GPR[CPU_REG_A0] , DATA_DW ,  GS_IMR  ,0 ) ;			// (12001010 : GS_IMR) = A0
	
	INCREMENT_PC();
} 



void SYSCALL_GetGsHParam( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}  



void SYSCALL_GetGsVParam( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_SetGsHParam( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_SetGsVParam( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   


/*
GsPutIMR	ENTRY_113	80000d40

12001010	IMR			Interrupt mask
*/
void SYSCALL_iGsPutIMR( ) 						{ 
	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();
	MipsCpu.PC = MipsCpu.PC + 4;
} 


/*
GsGetIMR	ENTRY_112	80000d00



*/
void SYSCALL_iGsGetIMR( ) 						{

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();
	MipsCpu.PC = MipsCpu.PC + 4;
} 



/**********************************************************************************************************
									EVENT 
***********************************************************************************************************/


void SYSCALL_RFU080_CreateEventFlag( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU081_DeleteEventFlag( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU082_SetEventFlag( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU083_iSetEventFlag( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU084_ClearEventFlag( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU085_iClearEventFlag( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU086_WaitEvnetFlag( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU087_PollEvnetFlag( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU088_iPollEvnetFlag( ) 			{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_RFU089_ReferEventFlagStatus( ) 	{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   

void SYSCALL_RFU090_iReferEventFlagStatus( )	{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     




/**********************************************************************************************************
										SIF									
***********************************************************************************************************/

void SYSCALL_sceSifDmaStat( ) 	{ 
	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo(); 
    
	MipsCpu.GPR[CPU_REG_V0].lo = -1;
	
	INCREMENT_PC();

	
}

SifClientData *scldat;
SifRpcCall	*srpccall;

/*
a0 : * SifDmaData : DMA contents
a1 : _u32 : len : sdd data count
*/
void SYSCALL_sceSifSetDma( ) 					{ 
	char temp_string[256];

   SifDmaData *sdd;
   _u32 sdd_adrr;
   _s32	sdd_data_count;
   
   SifCmdHdr *schdr;
   _u32 schdr_adrr;
   
   SifRpcBind *sbrpc;
   _u32	sbrpc_addr;
   

   _u32	scldat_addr;
  _u32	 srpccall_add ; 
  
  
   _u8	boucle;
   _u16	* ReadData  ;
  
  	_u32	SemaID;



	_u64	RPC_In_addr;
	_u64	RPC_Out_addr;

	_u32	*RPC_In_addr_p;
	_u32	*RPC_Out_addr_p;
  	
 
	_u128	dma_stat;			//DMAC_STAT value ( at adress 0x1000E010 )
 	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();
  

  
  	/*PCSX2 code : don't understand */
	sdd_data_count = (_s32)(MipsCpu.GPR[CPU_REG_A1].lo)  - 1;
 	if (sdd_data_count < 0) {
 		MipsCpu.PC = MipsCpu.PC + 4;
 		PrintToBIOSOutput (  "|data count < 0\n" );
   		return;
	}

 	sdd_adrr = (MipsCpu.GPR[CPU_REG_A0].lo & 0x01FFFFFF) + ( sdd_data_count * sizeof(struct _SifDmaData) );
 	sdd = (  SifDmaData * )	&MipsMemory [  sdd_adrr ];
/*
 	if ( debug_print_syscall == 1 )	{

		sprintf(temp_string,"|addr=%8.8lx, nb=%lx \n",(_u32)MipsCpu.GPR[CPU_REG_A0].lo, (_s32)sdd_data_count);PrintToBIOSOutput (  temp_string );
		PrintToBIOSOutput ( "|_SifDmaData\n" );
        sprintf(temp_string,"  |data:%8.8lx\n",sdd->data);PrintToBIOSOutput (  temp_string );
        sprintf(temp_string,"  |addr:%8.8lx\n",sdd->addr);PrintToBIOSOutput (  temp_string );
     	sprintf(temp_string,"  |size:%8.8lx\n",sdd->size);PrintToBIOSOutput (  temp_string );
    	sprintf(temp_string,"  |mode:%8.8lx\n",sdd->mode);PrintToBIOSOutput (  temp_string );
	
	}
*/	
  	if ( ( sdd->data == 0 ) || 	( sdd->addr == 0 ) ) {
	    MipsCpu.GPR[CPU_REG_V0].lo = 1 ;
		MipsCpu.PC = MipsCpu.PC + 4;
		return;
	}
	
	/*
	sdd->data : is address of data to be send
	Read the Header of Data to be send
	*/
	schdr_adrr  = sdd->data & 0x01FFFFFF;		
	schdr = (struct _SifCmdHdr*)&MipsMemory [  schdr_adrr ];	
/*
 	if ( debug_print_syscall == 1 )	{
	
	    PrintToBIOSOutput ( "  |_HeaderOfDataToSend(SifCmdHdr)\n" );
        sprintf(temp_string,"    |size:%8.8lx\n",schdr->size);PrintToBIOSOutput (  temp_string );
        sprintf(temp_string,"    |daddr:%8.8lx\n",schdr->daddr);PrintToBIOSOutput (  temp_string );
    	sprintf(temp_string,"    |fcode:%8.8lx\n",schdr->fcode);PrintToBIOSOutput (  temp_string );
    	sprintf(temp_string,"    |opt:%8.8lx\n",schdr->opt);PrintToBIOSOutput (  temp_string );
	}
*/

	/* fcode is the code number to call */

	switch( schdr->fcode ) {
		
		/*0x80000000*/
		case SIF_CMDC_CHANGE_SADDR: 
			if ( debug_print_syscall == 1 )	PrintToBIOSOutput ( "    |CHANGE_SADDR\n" );
		break;
		
		/*0x80000001*/
		case SIF_CMDC_SET_SREG: 
			if ( debug_print_syscall == 1 )	PrintToBIOSOutput ( "    |SET_SREG\n" );
		break;

		/*0x80000002*/
		case SIF_CMDC_INIT_CMD: 
			if ( debug_print_syscall == 1 )	PrintToBIOSOutput ( "    |INIT_CMD\n" );
		break;

		/*0x80000003*/
		case SIF_CMDC_RESET_CMD: 
			if ( debug_print_syscall == 1 )	PrintToBIOSOutput ( "    |RESET_CMD\n" );
		break;



		/* Bind RPC */
		case 0x80000009: 
			/* Read the Bind Info */
			sbrpc_addr 	= sdd->data & 0x01FFFFFF;
			sbrpc 		= (struct _SifRpcBind*)&MipsMemory [  sbrpc_addr ];
/*			
			// Show  Bind Info
			if ( debug_print_syscall == 1 )	{
				PrintToBIOSOutput ( "    |BindRPC\n" );
				sprintf(temp_string,"    |rec_id:%8.8lx\n",sbrpc->rec_id);PrintToBIOSOutput (  temp_string );					
				sprintf(temp_string,"    |pkt_addr:%8.8lx\n",sbrpc->pkt_addr);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"    |rpc_id:%8.8lx\n",sbrpc->rpc_id);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"    |client_addr:%8.8lx\n",sbrpc->client_addr);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"    |rpc_number:%8.8lx\n",sbrpc->rpc_number);PrintToBIOSOutput (  temp_string );
			}
*/			
			/* Read the Client Info */
			scldat_addr = sbrpc->client_addr & 0x01FFFFFF;
			scldat		=(struct _SifClientData*)&MipsMemory [  scldat_addr ];
/*
			//Show Client Info 
			if ( debug_print_syscall == 1 )	{
				PrintToBIOSOutput ( "    |_ClientData\n" );
				sprintf(temp_string,"     |rpcdat.paddr:%8.8lx\n",scldat->rpcd.paddr);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |rpcdat.pid:%8.8lx\n",scldat->rpcd.pid);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |rpcdat.tid:%8.8lx\n",scldat->rpcd.tid);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |rpcdat.mode:%8.8lx\n",scldat->rpcd.mode);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |command:%8.8lx\n",scldat->command);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |buff:%8.8lx\n",scldat->buff);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |cbuff:%8.8lx\n",scldat->cbuff);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |func:%8.8lx\n",scldat->func);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |para_add:%8.8lx\n",scldat->para_add);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |serve_add:%8.8lx\n",scldat->serve_add);PrintToBIOSOutput (  temp_string );
			}
*/			
			/* Update Current Semaphore */
			SemaID = scldat->rpcd.tid;
			Ps2Bios.Sema[ SemaID ].currentCount = Ps2Bios.Sema[ SemaID ].currentCount - 1;
	
			/* Pass the RPC ID to Server */
			scldat->serve_add	= sbrpc->rpc_number;
			

		break;

		
		/* Call RPC */
		case 0x8000000a: 
			/* Read the Call Info */
			srpccall_add = sdd->data & 0x01FFFFFF;
			srpccall		=(struct _SifRpcCall*)&MipsMemory [  srpccall_add ];

			/* Read the Client Info */
			scldat_addr = srpccall->client_addr & 0x01FFFFFF;
			scldat		=(struct _SifClientData*)&MipsMemory [  scldat_addr ];
			
			if ( debug_print_syscall == 1 )	PrintToBIOSOutput ( "    |_CallRPC\n" );

			/* Update the Semaphore */
			SemaID = scldat->rpcd.tid;
			Ps2Bios.Sema[ SemaID ].currentCount = Ps2Bios.Sema[ SemaID ].currentCount - 1;


 			/*PCSX2 : don't understand */
			sdd_data_count = (_s32)sdd_data_count  - 1;
 
			/* Get the Sif Dma Data pointer */
 			sdd_adrr = (MipsCpu.GPR[CPU_REG_A0].lo & 0x01FFFFFF) + ( sdd_data_count * sizeof(struct _SifDmaData) );
 			sdd = (  SifDmaData * )	&MipsMemory [  sdd_adrr ];

			/* Set In and Out Buffer Add */
			RPC_In_addr 	= sdd->data ;
			RPC_Out_addr	= srpccall->receive_add ;
 
			if ( debug_print_syscall == 1 ) { 
				sprintf(temp_string,"      |In Addr:%8.8lx\n",RPC_In_addr);PrintToBIOSOutput (  temp_string ); 
				sprintf(temp_string,"      |Out Addr:%8.8lx\n",RPC_Out_addr);PrintToBIOSOutput (  temp_string );
			}

			RPC_In_addr_p = (_u32*)&MipsMemory [  RPC_In_addr & 0x01FFFFFF ];
			RPC_Out_addr_p = (_u32*)&MipsMemory [  RPC_Out_addr & 0x01FFFFFF ];
		


			/* What is the Server ?*/
			switch ( scldat->serve_add ) {

				// padman 
				case PAD_BIND_RPC_ID1:
					if ( debug_print_syscall == 1 )	PrintToBIOSOutput ( "      |padman-1\n" );	

					RPC_8000010f_PadMan1( srpccall->rpc_number, RPC_In_addr, RPC_Out_addr );

				break;


				case 0x80000001:	nsx2SIFBindModule[BIND_0x80000001].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000003:	nsx2SIFBindModule[BIND_0x80000003].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000400:	nsx2SIFBindModule[BIND_0x80000400].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000592:	nsx2SIFBindModule[BIND_0x80000592].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000593:	nsx2SIFBindModule[BIND_0x80000593].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000595:	nsx2SIFBindModule[BIND_0x80000595].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000596:	nsx2SIFBindModule[BIND_0x80000596].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000597:	nsx2SIFBindModule[BIND_0x80000597].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x8000059a:	nsx2SIFBindModule[BIND_0x8000059a].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000601:	nsx2SIFBindModule[BIND_0x80000601].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000006:	nsx2SIFBindModule[BIND_0x80000006].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				//case 0x8000010f:	nsx2SIFBindModule[BIND_0x8000010f].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x8000011f:	nsx2SIFBindModule[BIND_0x8000011f].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000100:	nsx2SIFBindModule[BIND_0x80000100].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000101:	nsx2SIFBindModule[BIND_0x80000101].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case AMIGAMOD_IRX:	nsx2SIFBindModule[BIND_AMIGAMOD_IRX].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case SJPCM_IRX:		nsx2SIFBindModule[BIND_SJPCM_IRX].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case RPC_NPM_USER:	nsx2SIFBindModule[BIND_RPC_NPM_USER].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				//case ????:	nsx2SIFBindModule[BIND_RPC_NPM_USER].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break




				default: 	/*if ( debug_print_syscall == 1 )*/ { sprintf(temp_string,"     |serve_add:%8.8lx Unknown\n",scldat->serve_add);PrintToEmuOutput (  temp_string );}

			}

		break;


		default: /*if ( debug_print_syscall == 1 ) {*/ sprintf(temp_string,"     |fcode:%8.8lx is unknown\n",schdr->fcode);PrintToEmuOutput (  temp_string ); 
				//} break;
	}


	/* Read DMAC_STAT value*/	
	MipsMemoryReadW ( SpecialAreaMemory, &dma_stat , (DMA_STAT & 0xFFFF) ) ;	//don't need DMA Check
	/* Set to 1 the flag of the interrupt */
	dma_stat.lo = dma_stat.lo | (1<<DMA_CH5);
	MipsMemoryWrite ( dma_stat  , DATA_W ,  DMA_STAT  ,0 ) ;

	/* Every thing OK */ 
    MipsCpu.GPR[CPU_REG_V0].lo = 1 ;



	MipsCpu.PC = MipsCpu.PC + 4;
} 


/*
isceSifSetDChain

//[module]	KERNEL
//[made by]	[RO]man & others (october 2002)

	int var_10;

	KSEG1_ADDR(D5_CHCR)	= 0;
	KSEG1_ADDR(D5_QWC)	= 0;
	KSEG1_ADDR(D5_CHCR)	= 0x184;	// 0001 1000 0100
	var_10	= KSEG1_ADDR(D5_CHCR);		// ?!?


*/
void SYSCALL_sceSifSetDChain( )  				{	
	_u128 temp128;
	
	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();		
/*
 	temp128.lo = 0;
	MipsMemoryWrite( temp128, DATA_W, DMA_5_CHCR, 0);	//KSEG1_ADDR(D5_CHCR)	= 0;
*/
 	temp128.lo = 0;
	MipsMemoryWrite( temp128, DATA_W, DMA_5_QWC, 0);	//KSEG1_ADDR(D5_QWC)	= 0;
	DmaUpdate();
	
 	temp128.lo = 0x184;
	MipsMemoryWrite( temp128, DATA_W, DMA_5_CHCR, 0);	//KSEG1_ADDR(D5_CHCR)	= 0x184;	// 0001 1000 0100
	DmaUpdate();

	/* var_10	= KSEG1_ADDR(D5_CHCR);		// ?!? */
	MipsCpu.GPR[CPU_REG_SP].lo =  MipsCpu.GPR[CPU_REG_SP].lo - 0x10 ;	

	MipsMemoryRead( &temp128, DATA_W, DMA_5_CHCR, 0 );	
	MipsMemoryWrite( temp128, DATA_W, MipsCpu.GPR[CPU_REG_SP].lo, 0);

	MipsCpu.GPR[CPU_REG_SP].lo =  MipsCpu.GPR[CPU_REG_SP].lo + 0x10 ;

	MipsCpu.PC = MipsCpu.PC + 4;
} 
 


void SYSCALL_sceSifSetReg( ) 					{ 


	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     

/*
sceSifGetReg
a0 ( _u16 ) : Register number
*/
void SYSCALL_sceSifGetReg( ) 					{
	
	if ( debug_print_syscall == 1 ) {
		SYSCALL_PrintDebugInfo();
    	printf("|a0=%llx\n", MipsCpu.GPR[CPU_REG_A0].lo);
	}
	
	MipsCpu.GPR[CPU_REG_V0].lo = 0x00060000;
	MipsCpu.PC = MipsCpu.PC + 4;
} 
 
void SYSCALL_sceSifStopDma( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   


void SYSCALL_isceSifSetDChain( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     



void SYSCALL_isceSifSetDma( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     



void SYSCALL_isceSifDmaStat( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     



/**********************************************************************************************************
																	
***********************************************************************************************************/






/*
RFU060_InitializeMainThread

Status : OK
*/
void	SYSCALL_RFU060() {
	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();
 		
	MipsCpu.GPR[CPU_REG_V0].lo = 0x81F00000 ;				
	INCREMENT_PC();

}

/*
RFU061_InitializeHeapArea

Status : OK
*/
void	SYSCALL_RFU061() {
	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();			
	
 	MipsCpu.GPR[CPU_REG_V0].lo =	MipsCpu.GPR[CPU_REG_A0].lo + MipsCpu.GPR[CPU_REG_A1].lo ;
  	
	INCREMENT_PC();

}


/*
End of Heap

Status : OK
*/
void SYSCALL_EndOfHeap( ) 						{ 
	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();
 	
 	MipsCpu.GPR[CPU_REG_V0].lo = 0x80000000;
 
 	INCREMENT_PC();
}

  



void SYSCALL_RFU063( ) 							{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();MipsCpu.halt = 1; 
}  




void SYSCALL_KSeg0( ) 							{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_EnableCache( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}  



void SYSCALL_DisableCache( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_GetCop0( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   

/*
FlushCache 0x64 100
Do Nothing
*/
void SYSCALL_FlushCache( ) 						{ 
    static _u64 NbFlushCache = 0;;

	if ( debug_print_syscall == 1 )	{
//        SYSCALL_PrintDebugInfo();	
    printf("FlushCache : n %5.5lld \n",NbFlushCache);

    }
	NbFlushCache++;
    MipsCpu.PC = MipsCpu.PC + 4;
}   



void SYSCALL_CpuConfig( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   






void SYSCALL_SetCPUTimerHandler( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_SetCPUTimer( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_ForceRead( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_ForceWrite( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   






void SYSCALL_SetPgifHandler( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}    



void SYSCALL_SetVSyncFlag( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}    

/*
SetSyscall
a0: numero
a1: add

*/
void SYSCALL_RFU116( ) 							{ 
	char temp_string[256];
	
	if ( debug_print_syscall == 1 )	{
		SYSCALL_PrintDebugInfo();	
		sprintf(temp_string,"|num: %d , addr: %8.8lx\n",MipsCpu.GPR[CPU_REG_A0].lo,MipsCpu.GPR[CPU_REG_A1].lo);
		PrintToBIOSOutput (  temp_string );
		PrintToBIOSOutput (  "|No Implemented\n" );
	}
	
    
    
    
    MipsCpu.PC = MipsCpu.PC + 4;
}    


void SYSCALL_print( ) 							{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}    






void SYSCALL_ExecOSD( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     



void SYSCALL_Deci2Call( ) 						{ 

	if ( debug_print_syscall == 1 ) SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     



void SYSCALL_PSMode( ) 							{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     



void SYSCALL_MachineType( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     



void SYSCALL_GetMemorySize( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     









void SYSCALL_iCpuConfig( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL_iFlushCache( ) 					{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     


void SYSCALL_iGetCop0( ) 						{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}     




void SYSCALL_RFU091( ) 							{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   













void SYSCALL_UKN_1() { 
	
	if ( debug_print_syscall == 1 )	{
		SYSCALL_PrintDebugInfo();	
		printf("|???\n");
	}
	
	//MipsCpu.halt = 1;
	MipsCpu.PC = MipsCpu.PC + 4; 
}    

void SYSCALL_RFU101_105() {
	
	if ( debug_print_syscall == 1 )	{
		SYSCALL_PrintDebugInfo();	
		printf("|???\n");
	}
	
	MipsCpu.halt = 1;


}

void SYSCALL_RFU073( ) 							{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_SetOsdConfigParam( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   



void SYSCALL_GetOsdConfigParam( ) 				{ 

	if ( debug_print_syscall == 1 )	SYSCALL_PrintDebugInfo();	MipsCpu.halt = 1; 
}   


void SYSCALL_SetOsdConfigParam2() {

	
	if ( debug_print_syscall == 1 )	{
		SYSCALL_PrintDebugInfo();	
		printf("|???\n");
	}
	
	MipsCpu.halt = 1;



}



