/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdlib.h>
#include <stdio.h>

#include "nSX2.h"
#include "PS2Edefs.h"

/*
The 4 first Timer is for the PS2
the 5th timer is for the emu.


For the moment, I only work with TIMER_4
*/

/*
Initialisation of the specified Timer
*/
void TimerInit( _u8 TimerID ) {
	char tempText[256];	
	
	switch ( TimerID ) {
	
		case NSX2_TIMER: {
				//Ps2Bios.Timer[ NSX2_TIMER ].comp 	= 314572800 / 960 ;
				Ps2Bios.Timer[ NSX2_TIMER ].comp 	=	10000 ;
				Ps2Bios.Timer[ NSX2_TIMER ].count 	= 0;
    			Ps2Bios.Timer[ NSX2_TIMER ].mode_param.CUE 	= TRUE;		//the Timer is running
				Ps2Bios.Timer[ NSX2_TIMER ].mode_param.EQUF = FALSE;
 				Ps2Bios.Timer[ NSX2_TIMER ].mode_param.OVFF	= FALSE;
				break;
		}
	
	}
}


/*

*/
void TimerInterrupt ( void ) {
  
    /* If an Overflow Occur */
        if ( Ps2Bios.Timer[ NSX2_TIMER ].mode_param.OVFF == TRUE ) {
		        TimerInit( NSX2_TIMER );          			//Reset the Timer to Initial Value
				
				/* 	an acces To GS_CRT isn't detected 
					I need to Update the Screen
				*/
		        if( !Ps2Bios.AccesToGS ) Ps2Bios.NeedUpdateScreen 	= TRUE;			
				
				/* Need to Update Pad Status */
				Ps2Bios.NeedUpdatePad 		= TRUE;
				
				//PrintToEmuOutput("Timer 4 Reset by TIMER CONTROLLER");
		}
	


}


void TimerUpdate( void ) {
	char tempText[256];
	static _u64	Previous_NbOfInstructions=0;

	/* 	Check the Timer Interrupt */
	TimerInterrupt ( );
	
	/* Check if the number of Instruction is overflow */
	if ( MipsCpu.Nb_instructions < Previous_NbOfInstructions ) Previous_NbOfInstructions = 0;

	/* Update the count Val */
	Ps2Bios.Timer[ NSX2_TIMER ].count 	= Ps2Bios.Timer[ NSX2_TIMER ].count + ( MipsCpu.Nb_instructions -  Previous_NbOfInstructions ) ;

	/* Check if a Timer Overflow Occur*/
	if ( (_u64)Ps2Bios.Timer[ NSX2_TIMER ].count > (_u64)Ps2Bios.Timer[ NSX2_TIMER ].comp ) Ps2Bios.Timer[ NSX2_TIMER ].mode_param.OVFF	= TRUE;

	/* Save the Current Number of Instruction */
	Previous_NbOfInstructions = MipsCpu.Nb_instructions;

}





